#ifndef CONFIGMGR_H
#define CONFIGMGR_H

#include "gmDefs.h"

#include <wx/xml/xml.h>
#include <wx/variant.h>

#include "gmConfig.h"
#include "XmlUtil.h"

namespace Config {
class ConfigMgr {
    public:
        ConfigMgr();
        ConfigMgr(const wxString& fileName);
        virtual ~ConfigMgr() {}
        virtual bool write(const wxString& itemName, long id, const wxString& value) = 0;
        virtual wxString read(const wxString& itemName, long key) = 0;
        virtual wxString read(long key) = 0;
        virtual gmConfig *loadConfig() = 0;
        virtual bool setConfig(const gmConfig *conf) = 0;
    protected:
        wxString long2str(long i) {
            wxVariant val(i);
            return val.GetString();
        }
};
}

#endif // CONFIGMGR_H
