/***************************************************************
 * Name:      GikoMonaMain.h
 * Purpose:   Defines Application Frame
 * Author:     ()
 * Created:   2009-08-05
 * Copyright:  ()
 * License:
 **************************************************************/

#ifndef GIKOMONAMAIN_H
#define GIKOMONAMAIN_H

#include "gmDefs.h"

#include <vector>
#include <map>
#include <string>

//(*Headers(GikoMonaFrame)
#include <wx/listctrl.h>
#include <wx/treectrl.h>
#include <wx/notebook.h>
#include <wx/menu.h>
#include <wx/panel.h>
#include <wx/frame.h>
#include <wx/statusbr.h>
#include <wx/splitter.h>
//*)
#include "Setting.h"
#include "TVWindow.h"
#include "IO.ListMaker.ThreadListMaker.h"
#include "BbsMgr.h"
#include "gmControls.h"
#include "gmGuiMgr.h"

#include <wx/thread.h>
#include <lua.hpp>
#include <wx/string.h>

//extern TVWindow *TVWnd;
//extern bool isOpenedTVWindow;

class gmGuiMgr;

class GikoMonaFrame: public wxFrame
{
    public:

        GikoMonaFrame(gmGuiMgr* gui, wxWindow* parent = NULL, wxWindowID id = -1);
        virtual ~GikoMonaFrame();
        void getThread(const wxString& boardName, unsigned long thrdId, const wxString& threadTitle, bool isLocal);
        void getThreadList(unsigned long brdId, bool isLocal);
        void getBoardList(bool isLocal);
        bool Destroy();

    private:

        //(*Handlers(GikoMonaFrame)
        void OnQuit(wxCommandEvent& event);
        void OnAbout(wxCommandEvent& event);
        void OnMenuOpenTVClick(wxCommandEvent& event);
        void OnMenuSettingClick(wxCommandEvent& event);
        void OnMenuShowReleaseNoteClick(wxCommandEvent& event);
        void OnMenuBoardListRenewalClick(wxCommandEvent& event);
        void OnTreeCtrl1SelectionChanged(wxTreeEvent& event);
        void OnListCtrlItemClicked(wxListEvent& event);
        //*)

        void OnCloseWindow(wxCloseEvent& event);

        std::vector<wxListCtrl*> vListCtrl;
        //std::map<std::wstring, std::wstring> urlTable;
        //std::map<std::wstring, std::wstring> hostTable;

        typedef std::vector<wxListCtrl*> ListCtrlList;

        //(*Identifiers(GikoMonaFrame)
        static const long ID_TREECTRL1;
        static const long ID_PANEL5;
        static const long ID_TREECTRL2;
        static const long ID_PANEL6;
        static const long ID_TREECTRL3;
        static const long ID_PANEL7;
        static const long ID_TREECTRL4;
        static const long ID_PANEL8;
        static const long ID_NOTEBOOK2;
        static const long ID_PANEL2;
        static const long ID_TREECTRL5;
        static const long ID_PANEL3;
        static const long ID_TREECTRL6;
        static const long ID_PANEL4;
        static const long ID_NOTEBOOK1;
        static const long ID_LISTCTRL1;
        static const long ID_PANEL9;
        static const long ID_NOTEBOOK3;
        static const long ID_PANEL1;
        static const long ID_SPLITTERWINDOW1;
        static const long ID_Main_Menu_File_OpenTV;
        static const long ID_Main_Menu_File_Import;
        static const long ID_Main_Menu_File_Export;
        static const long ID_Main_Menu_File_Quit;
        static const long ID_Main_Menu_Board_Renewal;
        static const long ID_Main_Menu_ThreadList_Renewal;
        static const long ID_Main_Menu_Search_Thread;
        static const long ID_Main_Menu_Search_Board;
        static const long ID_Main_Menu_Search_Option_Enable_Regex;
        static const long ID_Main_Menu_Search_Option;
        static const long ID_Main_Menu_Setting_Set;
        static const long ID_Main_Menu_Help_ShowReleaseNote;
        static const long ID_Main_Menu_Help_About;
        static const long ID_STATUSBAR1;
        //*)

        Setting *SettingWnd;

        //(*Declarations(GikoMonaFrame)
        wxMenuItem* MenuItem8;
        wxPanel* Panel5;
        wxMenuItem* MenuItem7;
        wxListCtrl* ListCtrl1;
        wxNotebook* Notebook1;
        wxMenuItem* MenuItem5;
        wxPanel* Panel4;
        wxMenu* Menu3;
        wxTreeCtrl* TreeCtrl4;
        wxMenuItem* MenuItem4;
        wxTreeCtrl* TreeCtrl6;
        wxPanel* Panel9;
        wxTreeCtrl* TreeCtrl5;
        wxPanel* Panel8;
        wxTreeCtrl* TreeCtrl2;
        wxPanel* Panel1;
        wxPanel* Panel6;
        wxPanel* Panel3;
        wxMenuItem* MenuItem3;
        wxTreeCtrl* TreeCtrl3;
        wxPanel* Panel7;
        wxStatusBar* StatusBar1;
        wxMenuItem* MenuItem6;
        wxMenuItem* MenuItem9;
        wxTreeCtrl* TreeCtrl1;
        wxPanel* Panel2;
        wxNotebook* Notebook2;
        wxNotebook* Notebook3;
        wxMenu* Menu5;
        wxMenu* Menu4;
        //*)
        wxMenu* Menu1;
        wxMenu* Menu2;
        wxMenu* Menu6;
        wxMenu* SearchOptionMenu;
        wxMenuItem* MenuItem15;
        wxMenuItem* MenuItem14;
        wxMenuItem* MenuItem13;
        wxMenuItem* MenuItem12;
        wxMenuItem* MenuItem11;
        wxMenuItem* MenuItem10;
        wxMenuItem* MenuItem2;
        wxMenuItem* MenuItem1;
        wxMenuBar* MenuBar1;
        wxSplitterWindow *SplitterWindow1;

        wxBoxSizer *BoxSizer1, *BoxSizer2, *BoxSizer3, *BoxSizer4,
                   *BoxSizer6, *BoxSizer5, *BoxSizer7, *BoxSizer8,
                   *BoxSizer9;

        gmGuiMgr *guiMgr;

        DECLARE_EVENT_TABLE()
};

#endif // GIKOMONAMAIN_H
