#ifndef wxStringHREADDAwxStringA_H_INCLUDED
#define wxStringHREADDAwxStringA_H_INCLUDED


#include "gmDefs.h"

#include <wx/string.h>

namespace BBS {
    /**
    * @brief  It has address data.
    *        I think that "DataInfo" is wrong as the name.
    *        So, It will be changed to named "AddrData"(may be...).
    *        You haven't use it.
    */
    struct DataInfo {
    private:
        /// @brief use toThreadPath() and toThreadListPath().
        wxString inPrivate;
    public:
        wxString HostKey;
        wxString BoardKey;
        wxString ThreadKey;
        wxString& toThreadPath() {
            wxString temp = ThreadKey.Mid(0, 4);
            inPrivate = _T("Log\\2ch.net\\") + BoardKey + _T("\\") + temp + _T("\\") + ThreadKey + _T(".dat");
            return inPrivate;
        }
        wxString& toThreadListPath() {
            inPrivate = _T("Log\\2ch.net\\") + BoardKey + _T("\\subject.txt");
            return inPrivate;
        }
        DataInfo(const wxString& host, const wxString& board, const wxString& thread) {
            HostKey = host;
            BoardKey = board;
            ThreadKey = thread;
        }
        DataInfo(const wxString& host, const wxString& board) {
            HostKey = host;
            BoardKey = board;
        }
        DataInfo(const wxString& host) {
            HostKey = host;
        }
        DataInfo() {}
        ~DataInfo() {}
        DataInfo(const DataInfo& info) {
            HostKey = info.HostKey;
            BoardKey = info.BoardKey;
            ThreadKey = info.ThreadKey;
        }
        DataInfo& operator=(const DataInfo& info) {
            HostKey = info.HostKey;
            BoardKey = info.BoardKey;
            ThreadKey = info.ThreadKey;
            return *this;
        }
    };

    struct InfoAboutThread {
        wxString GettedTime;
        wxString Size;
    };

}

#endif // wxStringHREADDAwxStringA_H_INCLUDED
