#ifndef LOGMGR_H
#define LOGMGR_H

#include <wx/textfile.h>
#include <wx/datetime.h>
#include <wx/thread.h>

class LogMgr
{
    public:
        LogMgr() {}
        ~LogMgr() {}
        bool init();
        bool done();
        bool writeInfo();
        bool isOpen() { return isOpened; }
        bool write(const wxString& msg);
        bool dbgWrite(const wxString& msg);
    protected:
    private:
        bool isOpened;
        LogMgr(const LogMgr& other) {}
        LogMgr& operator=(const LogMgr& other) {}
        bool writeToFile(const wxString& msg);
        wxTextFile *file;
        wxMutex *fMutex;
};

#ifdef __WXDEBUG__
    #define DWRITE(class, func, str)                                        \
        logger.dbgWrite(__FILE__, class, func, str);
    #define DWRITE_INT(class, func, var)                                    \
        logger.dbgWrite(__FILE__, class, func, var);
    #define WRITE_LOG(class, func, str)
    #define WRITE_ERRLOG(class, func, errlevel, str)
#else
    #define DWRITE(class, func, str)
    #define DWRITE_INT(class, func, var)
    #define WRITE_LOG(class, func, str)                                     \
        logger.write(__FILE__, class, func, str);
    #define WRITE_ERRLOG(class, func, errlevel, str)                        \
        logger.write(__FILE__, class, func, str);
#endif

#endif // LOGMGR_H
