#ifndef TVWINDOW_H
#define TVWINDOW_H


#include "gmDefs.h"

#include <list>
#include <utility>

#include <wx/aui/aui.h>
#include <wx/aui/auibook.h>

//(*Headers(TVWindow)
#include <wx/notebook.h>
#include <wx/sizer.h>
#include <wx/menu.h>
#include <wx/toolbar.h>
#include <wx/panel.h>
#include <wx/frame.h>
#include <wx/html/htmlwin.h>
#include <wx/statusbr.h>
//*)
#include "gmGuiMgr.h"
#include "gmControls.h"

class gmGuiMgr;

class TVWindow : public wxFrame
{
public:
	TVWindow(gmGuiMgr *gui, wxWindow* parent = NULL,wxWindowID id=wxID_ANY,const wxPoint& pos=wxDefaultPosition,const wxSize& size=wxDefaultSize);
	virtual ~TVWindow();
	//(*Declarations(TVWindow)
	wxToolBar* ToolBar1;
	wxMenu Menu1;
	wxNotebook* Notebook1;
	wxToolBarToolBase* ToolBarItem3;
	wxPanel* Panel1;
	wxPanel* Panel3;
	wxToolBarToolBase* ToolBarItem1;
	wxHtmlWindow* HtmlWindow1;
	wxStatusBar* StatusBar1;
	wxPanel* Panel2;
	wxNotebook* Notebook2;
	wxToolBarToolBase* ToolBarItem2;
	//*)
	wxAuiManager *auiMgr;
	wxAuiNotebook *auiNotebook1; // Notebook1の代わりとしてこれを使う。
	wxTreeCtrl *treeCtrl1;       // Notebook1の代わりとしてこれを使う。

	void OnHtmlLinkClicked(wxHtmlLinkEvent& event);
	void OnCloseWindow(wxCloseEvent& event);
	void OnToolbarChangeTabStyleClicked(wxCommandEvent& event);
	void OnChangeStyle2BasicTab(wxMenuEvent& event);
	void OnChangeStyle2AuiTab(wxMenuEvent& event);
	void OnChangeStyle2TreeTab(wxMenuEvent& event);
	void OnChangeStyle2ThreadTreeTab(wxMenuEvent& event);
	void addThread(const wxString& board, const wxString& text, const wxString& title);
	void addThreadNote(wxNotebook *threadNotebook, wxPanel *threadNotePanel, wxHtmlWindow *htmlWnd);
	std::pair<bool, size_t>& isAlreadyOpened(const wxString& bookName, wxNotebook *book);

	template<typename T>
	typename std::list<T>::iterator& rotateItr(typename std::list<T>::iterator& itr, std::list<T>& container, size_t count){
	    itr = container.begin();
	    for(size_t i = 0; i < count; i++){
	        itr++;
	    }
	    return itr;
	}

protected:
	//(*Identifiers(TVWindow)
	static const long ID_HTMLWINDOW1;
	static const long ID_PANEL3;
	static const long ID_NOTEBOOK2;
	static const long ID_PANEL2;
	static const long ID_NOTEBOOK1;
	static const long ID_PANEL1;
	static const long ID_STATUSBAR1;
	static const long ID_TOOLBARITEM1;
	static const long ID_TOOLBARITEM2;
	static const long ID_TOOLBARITEM4;
	static const long ID_TOOLBAR1;
	//*)
private:
	//(*Handlers(TVWindow)
	void OnToolbarCloseClicked(wxCommandEvent& event);
	//*)
	static const long ID_TV_Menu_Copy;
    static const long ID_TV_Menu_URLCopy;
    static const long ID_TV_Menu_OpenURLByNoDefaultBrowser;

    class TabMgr { // ツリータブはサポートしません。てかそんなことしたらstd::pair使ったりとかかなり汚くなると思うので。
        public:
            #include "TabMgr.h"
            TabMgr(wxWindow *parentWnd, std::list<wxHtmlWindow*>& htmlList,
                   std::list<wxNotebook*>& bookList, std::list<wxAuiNotebook*>& auiBookList)
                    : parent(parentWnd), htmlWndList(htmlList),
                      notebookList(bookList), auiNotebookList(auiBookList) {}
            virtual ~TabMgr() {}
        private:
            wxWindow *parent;
            std::list<wxHtmlWindow*> htmlWndList;
            std::list<wxNotebook*> notebookList;
            std::list<wxAuiNotebook*> auiNotebookList;
    };

    std::list<wxHtmlWindow*> htmlWndList;
    std::list<wxNotebook*> threadNoteList;
    std::list<wxAuiNotebook*> auiNoteList;
	std::pair<bool, size_t> bookPair;
	gmGuiMgr *guiMgr;
	TabMgr *tabMgr;

	DECLARE_EVENT_TABLE()
};
#endif
