wxNotebook *copyAllControlsFromAuiTab(wxAuiManager *aui, const wxAuiNotebook *book) {
    wxWindowList wndList = book->GetChildren();
    wxNotebook *wndTop = new wxNotebook(parent, wxNewId());
    // 最高4階層かな？SizerはwxWindowクラスを継承してないし。でも第3層から第4層のwxpanel-wxNotebookは関係が変わらないから、いじらなくておｋ
    // wxPanelが返ってくる、と思う
    size_t i = 0;
    for(wxWindowList::iterator itrTop = wndList.begin(); itrTop != wndList.end(); itrTop++) {
        wxBoxSizer *sizerTop = new wxBoxSizer(wxHORIZONTAL);
        // wxAuiNotebookが返ってくる、と思う
        for(wxWindowList::iterator itrSecond = wndList.begin(); itrSecond != wndList.end(); itrSecond++) {
            wxNotebook *wndSecond = new wxNotebook(*itrTop, wxNewId());
            // wxPanel-wxNotebookが返ってくる、と思う
            size_t j = 0;
            for(wxWindowList::iterator itrThird = wndList.begin(); itrThird != wndList.end(); itrThird++) {
                wxBoxSizer *sizerSecond = new wxBoxSizer(wxHORIZONTAL);
                wndSecond->AddPage(reinterpret_cast<wxPanel*>(*itrThird), (reinterpret_cast<wxAuiNotebook*>(*itrSecond))->GetPageText(j));
                sizerSecond->Add(wndSecond, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
                (reinterpret_cast<wxPanel*>(*itrThird))->SetSizer(sizerSecond);
                sizerSecond->Fit(*itrThird);
                sizerSecond->SetSizeHints(*itrThird);
                j++;
            }
            notebookList.push_back(wndSecond);
        }
        wndTop->AddPage(reinterpret_cast<wxPanel*>(*itrTop), book->GetPageText(i));
        sizerTop->Add(wndTop, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
        (reinterpret_cast<wxPanel*>(*itrTop))->SetSizer(sizerTop);
        sizerTop->Fit(*itrTop);
        sizerTop->SetSizeHints(*itrTop);
        i++;
    }
    auiNotebookList.clear();
    aui->UnInit();
    delete aui;
    return wndTop;
}

wxAuiManager *copyAllControlsFromBasicTab(const wxNotebook *book) {
    wxWindowList wndList = book->GetChildren();
    wxAuiManager *auiTop = new wxAuiManager(parent);
    wxAuiNotebook *wndTop = new wxAuiNotebook(parent, wxNewId());
    size_t i = 0;
    for(wxWindowList::iterator itrTop = wndList.begin(); itrTop != wndList.end(); itrTop++) {
        wxBoxSizer *sizerTop = new wxBoxSizer(wxHORIZONTAL);
        for(wxWindowList::iterator itrSecond = wndList.begin(); itrSecond != wndList.end(); itrSecond++) {
            wxAuiNotebook *wndSecond = new wxAuiNotebook(*itrTop, wxNewId());
            size_t j = 0;
            for(wxWindowList::iterator itrThird = wndList.begin(); itrThird != wndList.end(); itrThird++) {
                wxBoxSizer *sizerSecond = new wxBoxSizer(wxHORIZONTAL);
                wndSecond->AddPage(reinterpret_cast<wxPanel*>(*itrThird), (reinterpret_cast<wxNotebook*>(*itrSecond))->GetPageText(j));
                sizerSecond->Add(wndSecond, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
                (reinterpret_cast<wxPanel*>(*itrThird))->SetSizer(sizerSecond);
                sizerSecond->Fit(*itrThird);
                sizerSecond->SetSizeHints(*itrThird);
                j++;
            }
            auiNotebookList.push_back(wndSecond);
        }
        wndTop->AddPage(reinterpret_cast<wxPanel*>(*itrTop), book->GetPageText(i));
        sizerTop->Add(wndTop, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
        (reinterpret_cast<wxPanel*>(*itrTop))->SetSizer(sizerTop);
        sizerTop->Fit(*itrTop);
        sizerTop->SetSizeHints(*itrTop);
        i++;
    }
    auiTop->AddPane(wndTop, wxAuiPaneInfo().Name(wxT("notebook_content")).CenterPane().PaneBorder(false));
    auiTop->Update();
    notebookList.clear();
    delete book;
    return auiTop;
}

