#ifndef CONFIG_CONFIGMGR_H
#define CONFIG_CONFIGMGR_H


#include "gmDefs.h"

#include <wx/xml/xml.h>

/*
*   使うの：
*       .history.xml
*       .config.xml
*       .abone.Name.xml
*       .abone.Id.xml
*       .abone.Mail.xml
*       .abone.Text.xml
*       .abone.FreeWord.xml
*       .abone.AA.xml
*       .abone.File.xml
*       samba24.xml
*       replaceStr.xml
*       replaceURL.xml
*/

namespace Config {

class XmlMgr;

struct XmlProp {
    wxString Attribute;
    wxString Value;
    XmlProp(const wxString& attr, const wxString& val) {
        Attribute = attr;
        Value = val;
    }
};

class XmlUtil {
    friend class XmlMgr;
    public:
        bool create(const wxString& fileName, const wxString& rootName);
        bool searchNode(const wxXmlNode *node, const wxXmlNode *seekBegin);
        wxXmlNode *searchNode(const wxString& nodeName);
        bool searchNodeFromChildren(const wxXmlNode *node, const wxXmlNode *parent);
        bool searchNodeFromNext(const wxXmlNode *node, const wxXmlNode *seekBegin);
        bool compareNode(const wxXmlNode *node1, const wxXmlNode *node2);
        bool hasChildren(wxXmlNode *parent) { parent->GetChildren() != NULL; }
        bool hasNext(wxXmlNode *node) { node->GetNext() != NULL; }
        wxXmlDocument *getDoc() { return doc; }
        wxXmlNode *getRoot() { return rootNode; }

    private:
        XmlUtil();
        XmlUtil(const wxString& fileName, const wxString& rootName);
        virtual ~XmlUtil();
        wxXmlDocument *doc;
        wxXmlNode *rootNode;
        wxString appDirPath;
        wxString xml_filename;
        bool isOpen;
        wxXmlNode *xml_node;
        wxXmlProperty *xml_prop;
};

} // namespace Config

#endif // CONFIG_CONFIGMGR_H
