/*
*   gmDefs.h
*
*   global define in GikoMona.
*   author  :   caprice(chemicl_t)
*   created :   ?
*/

#ifndef GMDEFS_H
#define GMDEFS_H

#ifdef  gm_WITHOUT_BUGBEARD
    #define BUG_DISABLE_BUGBEARD
#endif

#if     defined(gm_FULL_DEBUG)
    #define __WXDEBUG__
    #define LIB2CH_DEBUG
    #define LIBTWITTER_CXX_DEBUG
    #define BUG_EVIL_CONTRACT
#else   defined(gm_DEBUG_WITHOUT_WX)
    #define LIB2CH_DEBUG
    #define LIBTWITTER_CXX_DEBUG
    #define BUG_EVIL_CONTRACT
#endif

#include "lib2ch.h"

#define AUTHOR              _T("caprice")
#define BOARDFILE_NAME      _T("2ch.brd")

#ifdef TO_STR
    #undef TO_STR
#endif

// macro's integer => C style string...
#define TO_STR(s)           TO_STR_(s)
#define TO_STR_(s)          #s

/* gikomona version ************************************************************/
#define GIKOMONA_VER_MAJOR      1
#define GIKOMONA_VER_MINOR      00

/*
    "GIKOMONA_VER_STATE" value...
    alpha   : 1
    beta    : 2
    rc      : 3

    none    : 0
*/
#define GIKOMONA_VER_STATE      3

#define GIKOMONA_VER_STATE_MINOR      3

#if     GIKOMONA_VER_STATE == 1
    #define gm_VER_STATE    "b"
#elif   GIKOMONA_VER_STATE == 2
    #define gm_VER_STATE    "a"
#elif   GIKOMONA_VER_STATE == 3
    #define gm_VER_STATE    "RC"
#endif

#define gm_MAJOR_VER        TO_STR(GIKOMONA_VER_MAJOR)
#define gm_MINOR_VER        TO_STR(GIKOMONA_VER_MINOR)
#define gm_VER_STATE_MINOR  TO_STR(GIKOMONA_VER_STATE_MINOR)

/* gikomona version checking ***************************************************/
#define gm_CHECK_VER(major, minor, state, state_minor)                                      \
            (GIKOMONA_VER_MAJOR == (major) && GIKOMONA_VER_MINOR == (minor) &&              \
             GIKOMONA_VER_STATE == (state) && GIKOMONA_VER_STATE_MINOR == (state_minor))

#define gm_VER gm_MAJOR_VER "." gm_MINOR_VER gm_VER_STATE gm_VER_STATE_MINOR
#define gm_UA  "Monazilla/1.0(GikoMona/" gm_VER ")"

#include <wx/app.h>
#include <wx/textfile.h>
#include <wx/filefn.h>
#include <wx/image.h>

struct Icons {
    wxImage write;
    wxImage renewal;
    wxImage tab;
};

#include "LogMgr.h"
#include "gmErrorDialog.h"
#include "GikoMonaApp.h"

DECLARE_APP(GikoMonaApp)

#endif

