#ifndef GMERRORDIALOG_H
#define GMERRORDIALOG_H

#include "gmDefs.h"

//(*Headers(gmErrorDialog)
#include <wx/statline.h>
#include <wx/button.h>
#include <wx/dialog.h>
#include <wx/html/htmlwin.h>
//*)

class gmErrorDialog: public wxDialog
{
	public:

		gmErrorDialog(wxWindow* parent,wxWindowID id=wxID_ANY,const wxPoint& pos=wxDefaultPosition,const wxSize& size=wxDefaultSize);
		virtual ~gmErrorDialog();
		void showError(const wxString& cause,        const wxString& msg,
                        const wxString& classname,    const wxString& funcname,
                        const wxString& linenum);

		//(*Declarations(gmErrorDialog)
		wxButton* Button1;
		wxButton* Button2;
		wxHtmlWindow* HtmlWindow1;
		wxStaticLine* StaticLine1;
		//*)

	protected:

		//(*Identifiers(gmErrorDialog)
		static const long ID_HTMLWINDOW1;
		static const long ID_STATICLINE1;
		static const long ID_BUTTON1;
		static const long ID_BUTTON2;
		//*)

	private:

		//(*Handlers(gmErrorDialog)
		void OnCopy2ClipBoardButtonClicked(wxCommandEvent& event);
		void OnButtonOKClicked(wxCommandEvent& event);
		//*)

		DECLARE_EVENT_TABLE()
};

extern void gmShowErrorDialog(const wxString& cause,        const wxString& msg,
                       const wxString& classname,    const wxString& funcname,
                       const wxString& linenum);
#endif

