#ifndef GMMODEL_H
#define GMMODEL_H

#include <vector>
#include <list>
#include <map>

#include <wx/string.h>
#include <wx/thread.h>

#include "IO.ListMaker.BoardListMaker.h"
#include "IO.ListMaker.ThreadListMaker.h"

struct BbsInfo {
    wxString name;
    unsigned long bbsId;
};

struct BoardInfo {
    BBS::ListMaker::BoardInfo brdInfo;
    //unsigned long bbsId;
    unsigned long brdId;
    BoardInfo(wxString name, unsigned long id) : brdId(id) {
        brdInfo.BoardName = name;
    }
    ~BoardInfo() {}
};

struct ThreadInfo {
    BBS::ListMaker::ThreadInfo thrdInfo;
    //unsigned long brdId;
    unsigned long thrdId;
    ThreadInfo(wxString name, wxString count, unsigned long id) : thrdId(id) {
        thrdInfo.Title = name;
        thrdInfo.ResCount = count;
    }
    ~ThreadInfo() {}
};

struct ResData {
    wxString Title;
    wxString Text;
    unsigned long ThreadId;
    ResData(const wxString& title, const wxString& text, unsigned long id) : Title(title), Text(text), ThreadId(id) {}
    ~ResData() {}
};

class gmModel {
    public:
        typedef std::vector< std::vector<BoardInfo> > BoardInfoLists;
        typedef std::vector<ThreadInfo> ThreadInfoList;
        gmModel();
        virtual ~gmModel();
        void setBrdInfoList(BoardInfoLists brdList) {}
        BoardInfoLists getBrdInfoList() {}
        void setThrdInfoList(BoardInfoLists brdList) {}
        BoardInfoLists getThrdInfoList() {}
    protected:
    private:
        struct ThreadData {
            const ThreadInfo& data;
        };
        struct BoardData {
            const BoardInfo& data;
            std::list<ThreadData> thrdData;
            bool isBoardTabOpened;
        };
#if defined(ENABLE_TWITTER)
        struct Twitter {
            wxString userName;
        };
#endif
        BoardInfoLists brdInfoLists;
        ThreadInfoList thrdInfoList;
        gmModel(const gmModel& other) {};
        gmModel& operator=(const gmModel& other) {};
        wxCriticalSection critSect;
        wxMutex *hostIdMutex;
        wxMutex *boardIdMutex;
        wxMutex *threadIdMutex;
        // 名前だと重複する可能性があるので、自前でIdを割り振ってやる。
        unsigned long hostId;
        unsigned long boardId;
        unsigned long threadId;
        std::map<unsigned long, BbsInfo> hostIdTable;
        std::map<unsigned long, BbsInfo> boardIdTable;
        std::map<unsigned long, BbsInfo> threadIdTable;
};
#endif // GMMODEL_H

