#include <map>

#include <wx/wfstream.h>

#include "gmXmlStreamParser.h"

using namespace std;

extern "C" {
    static void gmXmlElementTagStart(void *userData, const XML_Char *name, const XML_Char **attrs) {
        GikoMona::XmlStreamParserImpl *strmp = (GikoMona::XmlStreamParserImpl*)userData;
        wxString tagName(name, wxConvUTF8);
        wxString key, val;
        GikoMona::XmlStreamParserImpl::Attributes attr;
        while (*attrs) {
            key.FromUTF8(attrs[0]);
            val.FromUTF8(attrs[1]);
            attr.push_back(make_pair(key, val));
            attrs += 2;
        }
        strmp->onElementTag(tagName, attr);
    }
    static void gmXmlElementTagEnd(void *userData, const XML_Char *name) {}
}

namespace GikoMona {
XmlStreamParser::XmlStreamParser(XmlStreamParserImpl *impl) {
    XML_SetUserData(xml, (void*)impl);
    XML_SetElementHandler(xml, gmXmlElementTagStart, gmXmlElementTagEnd);
}

bool XmlStreamParser::parse(const wxString& fileName, size_t bufSize) {
    bool done;
    const size_t BUFSIZE = 1024;
    char buf[BUFSIZE];
    wxFileInputStream stream(fileName);
    do {
        size_t len = stream.Read(buf, BUFSIZE).LastRead();
        done = (len < BUFSIZE);
        if (!XML_Parse(xml, buf, len, done)) {
            XML_ParserFree(xml);
            return false;
        }
    } while (!done);
    return true;
}
}

