#ifndef GMXMLSAXPARSER_H
#define GMXMLSAXPARSER_H

#include <vector>

#include <lib/expat.h>
#include <wx/string.h>

namespace GikoMona {
struct XmlStreamParserImpl {
    typedef std::vector< std::pair<
                            wxString, // key
                            wxString  // value
                        > > Attributes;
    virtual void onElementTag(const wxString& tagName, Attributes& attr) {}
    virtual void onCharDataTag(const wxString& data) {}

};

class XmlStreamParser {
    public:
        XmlStreamParser(XmlStreamParserImpl *impl);
        ~XmlStreamParser() { XML_ParserFree(xml); }
        bool parse(const wxString& fileName, size_t bufSize);
    protected:
    private:
        XML_Parser xml;
        XmlStreamParserImpl *impl;
};
}
#endif // GMXMLSAXPARSER_H

