#ifndef wxStringHREADDAwxStringA_H_INCLUDED
#define wxStringHREADDAwxStringA_H_INCLUDED

#include <wx/string.h>

namespace BBS {
    struct AddressData {
        wxString HostKey;
        wxString BoardKey;
        wxString ThreadKey;
        AddressData(const wxString& host, const wxString& board, const wxString& thread) {
            HostKey = host;
            BoardKey = board;
            ThreadKey = thread;
        }
        AddressData(const wxString& host, const wxString& board) {
            HostKey = host;
            BoardKey = board;
        }
        AddressData(const wxString& host) {
            HostKey = host;
        }
        AddressData() : HostKey(wxEmptyString), BoardKey(wxEmptyString), ThreadKey(wxEmptyString) {}
        ~AddressData() {}
        wxString fromThreadUrl(const wxString& url);
        wxString fromThreadListUrl(const wxString& url);
        wxString toThreadPath();
        wxString toThreadListPath();
        wxString toThreadUrl();
        wxString toThreadListUrl();
        wxString toSettingUrl();
        wxString toLocalRuleUrl();
    };
}

#endif // wxStringHREADDAwxStringA_H_INCLUDED
