#ifndef BBS_TCP_IP_BBSMGR_H
#define BBS_TCP_IP_BBSMGR_H

#include "lib2ch.h"

#include <wx/string.h>

#include "AddrData.h"
#include "ConnectionMgr.h"
#include "IO.ListMaker.BoardListMaker.h"
#include "IO.ListMaker.ThreadListMaker.h"
#include "SQLMgr.h"

#include <string>
#include <map>
#include <vector>
#include <exception>

namespace BBS {

using namespace std;
using namespace ListMaker;

    class BbsMgr {
        public:
            BbsMgr() { db = new SQLite::SQLMgr; }
            BbsMgr(const wxString& usrAgent) : userAgent(usrAgent) { db = new SQLite::SQLMgr; }
            virtual ~BbsMgr() { delete db; }
            /// @bug この関数はTCP_IP::ConnectionMgr::Httpが通信中であることを確認していない
            bool abort() { return Mgr->Http->Abort(); }

            virtual pair<wstring, wstring> getThread(const AddressData& Info, bool isLocal) = 0;
            virtual vector<ThreadInfo> getTList(const AddressData& Info, bool isLocal) = 0;
            virtual vector< vector<BoardInfo> > getBoardList(const AddressData& Info, bool isLocal) = 0;
            virtual int postResponse(const AddressData& Info, const wxString& postedStr) = 0;
            virtual int makeThread(const AddressData& Info, const wxString& postedStr) = 0;

            virtual pair<wstring, wstring> getThread(const wxString& url, bool isLocal) = 0;
            virtual vector<ThreadInfo> getTList(const wxString& url, bool isLocal) = 0;
            virtual vector< vector<BoardInfo> > getBoardList(const wxString& url, bool isLocal) = 0;
            virtual int postResponse(const wxString& url, const wxString& postedStr) = 0;
            virtual int makeThread(const wxString& url, const wxString& postedStr) = 0;

        protected:
            wxString userAgent;
            TCP_IP::ConnectionMgr *Mgr;
            SQLite::SQLMgr *db;
            virtual AddressData createAddrDataFromUrl(const wxString& url) = 0;
        private:
    };

} // namespace BBS

#endif // BBS_TCP_IP_BBSMGR_H
