#ifndef THREADLISTMAKER_H_INCLUDED
#define THREADLISTMAKER_H_INCLUDED

#include "lib2ch.h"

#include <vector>
#include <wx/string.h>

namespace BBS{
namespace ListMaker{
    struct ThreadInfo {
        wxString Title;                 // タイトル
        wxString ResCount;              // 取得件数
        wxString LatestGetTime;         // 最新取得日時
        wxString LastWritting;          // 最終書き込み
        wxString NewResCount;           // 新着件数
        wxString LatestResWrittingTime; // 新着日時
        wxString ThreadMomentum;        // 勢い
        wxString ThreadId;              // スレッドの番号(0000000123.datの"0000000123"の部分)
    };
    class ThreadListMaker {
    public:
        /// @warning この関数は使用すべきではない。
        std::vector<ThreadInfo> MakeList(const wxString& Path);
        std::vector<ThreadInfo> makeList(const wxString& path) { return MakeList(path); }
        /**
        * @warning この関数は使用すべきではない。
        * @bug     同じ名前のスレッドが2つ以上同じ板にあった場合、                 <br>
        *          この関数はおそらく全ての同じ名前のスレッドに対して同じURLを返す。
        */
        wxString readThreadURL(const wxString& path, const wxString& threadName);
    private:
        wxString result;
        std::vector<ThreadInfo> vTList;
        std::vector<ThreadInfo>::iterator itr_vTList;
    };
}
}


#endif // THREADLISTMAKER_H_INCLUDED
