#ifndef BBS_MGR2CH_H
#define BBS_MGR2CH_H

#include "lib2ch.h"

#include <string>
#include <vector>
#include <map>

#include <wx/string.h>

#include "BbsMgr.h"
#include "IO.ListMaker.ThreadListMaker.h"
#include "IO.ListMaker.BoardListMaker.h"

namespace BBS {

using namespace std;
using namespace ListMaker;

class Mgr2ch : public BbsMgr {
    public:
        Mgr2ch() : BbsMgr() {}
        Mgr2ch(const wxString& usrAgent) : BbsMgr(usrAgent) {}

        pair<wstring, wstring> getThread(const AddressData& Info, bool isLocal);
        vector<ThreadInfo> getTList(const AddressData& Info, bool isLocal);
        vector< vector<BoardInfo> > getBoardList(const AddressData& Info, bool isLocal);
        int postResponse(const AddressData& Info, const wxString& postedStr);
        int makeThread(const AddressData& Info, const wxString& postedStr);

        pair<wstring, wstring> getThread(const wxString& url, bool isLocal) {
            return getThread(createAddrDataFromUrl(url), isLocal);
        }
        vector<ThreadInfo> getTList(const wxString& url, bool isLocal) {
            return getTList(createAddrDataFromUrl(url), isLocal);
        }
        vector< vector<BoardInfo> > getBoardList(const wxString& url, bool isLocal) {
            return getBoardList(createAddrDataFromUrl(url), isLocal);
        }
        int postResponse(const wxString& url, const wxString& postedStr) {
            return postResponse(createAddrDataFromUrl(url), postedStr);
        }
        int makeThread(const wxString& url, const wxString& postedStr) {
            return makeThread(createAddrDataFromUrl(url), postedStr);
        }

    private:
        pair<wstring, wstring> title_and_text;
        wxString DirName;
        wxString text;
        int response;
        vector<ThreadInfo> vList;
};

} // namespace BBS

#endif // BBS_MGR2CH_H
