#ifndef GMSQL_H
#define GMSQL_H

#include "lib2ch.h"

#include "sqlite++/SQLite++.h"
#include "IO.ListMaker.BoardListMaker.h"

#include <wx/string.h>

#include <vector>
#include <exception>
#include <cstring>

/*
*   GikoMonalog.db̎dl
*
*   ThreadListTable(name     TEXT NOT NULL, hostKey  TEXT NOT NULL,
*                   boardKey TEXT NOT NULL, last_mod TEXT NOT NULL,
*                   size     TEXT NOT NULL)
*
*       name            : ̖OB
*       hostKey         : Key.hQƁB
*       boardKey        : Key.hQƁB
*       last_mod        : ŏIXVB
*       size            : TCYB(𓀌)
*
*   ThreadTable(threadId  TEXT NOT NULL, name     TEXT NOT NULL,
*               threadKey TEXT NOT NULL, last_mod TEXT NOT NULL,
*               size      TEXT NOT NULL)
*
*       threadId        : Xbh̃t@CIDB
*       name            : Xbh̖OB
*       threadKey       : Key.hQƁB
*       last_mod        : ŏIXVB
*       size            : TCYB(𓀌)
*
*/

namespace SQLite {
    class SQLMgr {
        public:

            void createThreadListTable();
            void createThreadTable();
            bool entry2ThreadListTable(const wxString& boardName,
                                       const wxString& hostKey, const wxString& boardKey,
                                       const wxString& last_mod_time, const wxString& eTag,
                                       const wxString& size);
            bool entry2ThreadTable(const wxString& threadId,
                                   const wxString& threadName, const wxString& threadKey,
                                   const wxString& last_mod_time, const wxString& eTag,
                                   const wxString& size);
            bool deleteFromThreadListTable();
            bool deleteFromThreadTable(const wxString& threadId, const wxString& threadName);
            bool getLastModTimeAndSizeFromThreadListTable();
            bool getLastModTimeAndSizeFromThreadTable(const wxString& threadId, const wxString& threadName);
            bool renewalLastModTimeAndSizeFromThreadListTable(const wxString& last_mod_time, const wxString& size);
            bool renewalLastModTimeAndSizeFromThreadTable(const wxString& last_mod_time, const wxString& size);
            bool isAlreadyEntriedInThreadListTable(const wxString& hostKey, const wxString& boardKey);
            bool isAlreadyEntriedInThreadTable(const wxString& threadName, const wxString& threadKey);

            void execStmt(const char *sql) {
                SQLiteStatement *stmt = db->createStatement(sql);
                stmt->execute();
                delete stmt;
            }

            bool openDB(const wxString& path) {
                dbPath = path;
                try {
                    db->open(path.ToUTF8());
                }catch(std::exception& e) {
                    return false;
                }
                return true;
            }
            /** Default constructor */
            SQLMgr();
            /** Default destructor */
            virtual ~SQLMgr();

        private:

            /**
            * @return   Id (BoardId or ThreadListId or ThraedId...)
            *          If not found Item, It return 0.
            */
            int isExistItem(const char *table_name,
                            const char *name);
            bool isAlreadyCreatedTable(const char *teble_name);

            SQLiteConnection *db;
            wxString dbPath;
    };
}

#endif // GMSQL_H
