#ifndef TRANSLATOR_H
#define TRANSLATOR_H

#include "lib2ch.h"

#include <wx/string.h>

#include <vector>
#include <map>

#if gm_CHECK_COE_VER(2,0,0,0)

namespace BBS {
namespace Coe {
namespace v2 {
    const static wxChar *htmlBegin = _T("<html> \n")
                                       _T("<head> \n")
                                       _T("<meta http-equiv=\"Content-Type\" content=\"text/html; charset=Shift_JIS\"> \n")
                                       _T("<title>");
    const static wxChar *htmlMiddle = _T("</title>\n")
                                       _T("</head>\n")
                                       _T("<body>");
    const static wxChar *htmlEnd = _T("</body></html>");

    struct ResData {
            wxString name;
            wxString mail;
            wxString date;
            wxString id;
            wxString beId;
            wxString text;
            int refResList[];
            ResData(int resCount) {
                refResList = new int[resCount];
                loc = NAME;
            }
            ~ResData() { delete [] refResData; }
        private:
            ResData(const ResData& data) {}
    };

    struct ThreadInfo {
        wxString title;
        int allResesCount;
    };

    class Translator {
        public:
            Translator(const wxString& fileName);
            virtual ~Translator();
            std::pair<
                ThreadInfo,
                std::vector<wxString>
            > dat2Html();
        protected:
            virtual const std::pair<
                                ThreadInfo, // for title & all reses count
                                std::vector<ResData> // reses
                            >& parse(const wxString& text) = 0;
            wxString dat;
        private:
    };
}
}
}

#endif
#endif // TRANSLATOR_H
