/**
*   sqlitepp : sqliteconnection.h => gmSQLiteConnection.h
*
*   قƂǂ̊֐(w肪)͗O𓊂VXeɂȂĂ邽߁A
*   class gmSQLŃLb`邱ƁB(ݏ񂾂)
*/
#ifndef SQLITEPP_CONNECTION_H
#define SQLITEPP_CONNECTION_H

#include "SQLiteException.h"
#include "SQLiteStatement.h"
#include <cstring>

namespace SQLite {

class SQLiteConnection {

    sqlite3*			db_;

public:
    SQLiteConnection() {
        db_ = NULL;
    }

    /**
     * @throw ConnectionException I[vłȂ
     */
    SQLiteConnection(const char* dbFileName) {
        db_ = NULL;
        open(dbFileName);
    }

    virtual ~SQLiteConnection() {
        closeDB();
    }

    sqlite3* getDB() const {
        return db_;
    }

    /**
     * @throw ConnectionException I[vłȂ
     */
    void open(const char* dbFileName) {
        int errCode = sqlite3_open(dbFileName, &db_);

        if(SQLITE_OK != errCode) {
            std::string msg("SQLiteConnection::open() : ");
            msg.append(sqlite3_errmsg(db_));
            throw ConnectionException(msg.c_str());
        }
    }

    void closeDB() {
        if(db_) {
            sqlite3_close(db_);
            db_ = NULL;
        }
    }

    /**
     * sĂXe[ggIB
     * @note 荞܂ꂽXe[ggɂ́AG[R[hSQLITE_INTERRUPTQueryException
     */
    void interrupt() {
        if(db_) {
            sqlite3_interrupt(db_);
        }
    }

    /**
     * Xe[gg\z
     * @param sql sׂSQL
     * @return \zꂽXe[ggIuWFNgւ̃|C^
     */
    SQLiteStatement* createStatement(const char* sql) {
        // prepare statement
        sqlite3_stmt* stmt = NULL;
        const char* unused = NULL;
        int res = SQLITE_OK;

        res = sqlite3_prepare(db_, sql, -1, &stmt, &unused);

        if(SQLITE_OK == res) {
            return new SQLiteStatement(sql, stmt, db_);
        } else {
            std::string msg("SQLiteConnection::createStatement() : ");
            msg.append(sqlite3_errmsg(db_));
            throw QueryException(msg.c_str(), res);
        }
    }

    /// Xe[gg𒼂Ɏs
    void executeStatement(const char* sql) {
        char* errmsg = NULL;
        int res = sqlite3_exec(db_, sql, NULL, NULL, &errmsg);

        if (SQLITE_OK != res) {
            std::string msg("SQLiteConnection::executeStatement() : ");
            if (errmsg) {
                msg += errmsg;
                sqlite3_free(errmsg);
            }
            throw QueryException(msg.c_str(), res);
        }
    }

    /**
     * Ōɑ}j[NȍsID擾
     * @return Ōɑ}j[NȍsID
     */
    long long getLastInsertRowID() {
        return sqlite3_last_insert_rowid(db_);
    }

    /**
     * ŌINSERT, DELETE, UPDATE̎sŕύXꂽs̐擾
     * @return ύXꂽs
     * @note WHERE߂̂Ȃ DELETÉASQLiteDROP TABLECREATE TABLE
     *      s邱ƂɂĎĂB̏ꍇAlastChangedRowNum()
     *      K0ԂB
     */
    int getLastChangedRowNum() {
        return sqlite3_changes(db_);
    }

    /**
     * f[^x[XJĂύXꂽs擾
     * @return f[^x[XJĂύXꂽs
     */
    int getLastChangedRowNumTotal() {
        return sqlite3_total_changes(db_);
    }

/**
* ȉ2̊֐ȂstaticwɂȂĂ̂Ӗ킩ȂA
* 炭CN[hł̂ݎg悤ɉB̂낤B
* 2010:03/06 by caprice
*/

    /**
     * w肵񂪁ASQLƂĐĂ邩ǂ`FbN
     * @return SQLƂĐĂtrueAsSȂfalse
     */
    bool isCompleteSQL(const char* sql) {
        return sqlite3_complete(sql) != 0;
    }

    /// SQLitegpXbh[J\[X(ver 3.3.0ȍ~̋@\)
    void cleanupThread() {
        sqlite3_thread_cleanup();
    }
};

}

#endif

