#ifndef SQLITEPP_FUNCTION_H
#define SQLITEPP_FUNCTION_H

#include "SQLiteException.h"

#include <string>

namespace SQLite {

/// [U`֐/AOQ[g̃x[XƂȂNX
class SQLiteFunctionBase {
protected:

    /// ی삳ꂽRXgN^B̃NX𒼐ڃCX^X邱Ƃ͖B
    /**
     * @db SQLitef[^x[Xnh
     */
    SQLiteFunctionBase(sqlite3* db) : db_(db) {
        numArgs_ = 0;
        ctx_ = NULL;
        userData_ = NULL;
    }

public:
    /// ֐o^f[^x[Xnh
    sqlite3*			db_;
    /// ֐̌ĂяoReLXgێiSQLite֐Ăяoۂɓnj
    sqlite3_context*		ctx_;
    /// ֐(UTF8)
    std::string			name_;
    /// ֐̎̐
    int				numArgs_;
    /// ֐o^ɓn[Uf[^
    void*			userData_;

    virtual ~SQLiteFunctionBase() {}

    /// ֐ɓnꂽ̃^CvANULLł邩`FbN
    /**
     * @param param SQLiteFunction::onCall(), SQLiteAggregate::onStep() ɓnꂽ
     * @return ̃^CvNULLłtrueAłȂfalse
     */
    bool isNull(sqlite3_value* param) {
        return (sqlite3_value_type(param) == SQLITE_NULL);
    }

    /// ֐ɓnꂽ̃^CvAł邩`FbN
    /**
     * @param param SQLiteFunction::onCall(), SQLiteAggregate::onStep() ɓnꂽ
     * @return ̃^CvłtrueAłȂfalse
     */
    bool isString(sqlite3_value* param) {
        return (sqlite3_value_type(param) == SQLITE_TEXT);
    }

    /// ֐ɓnꂽ̃^CvAł邩`FbN
    /**
     * @param param SQLiteFunction::onCall(), SQLiteAggregate::onStep() ɓnꂽ
     * @return ̃^CvłtrueAłȂfalse
     */
    bool isInt(sqlite3_value* param) {
        return (sqlite3_value_type(param) == SQLITE_INTEGER);
    }

    /// ֐ɓnꂽ̃^CvAł邩`FbN
    /**
     * @param param SQLiteFunction::onCall(), SQLiteAggregate::onStep() ɓnꂽ
     * @return ̃^CvłtrueAłȂfalse
     */
    bool isReal(sqlite3_value* param) {
        return sqlite3_value_type(param) == SQLITE_FLOAT;
    }

    /// ֐ɓnꂽ̃^CvABLOBł邩`FbN
    /**
     * @param param SQLiteFunction::onCall(), SQLiteAggregate::onStep() ɓnꂽ
     * @return ̃^CvBLOBłtrueAłȂfalse
     */
    bool isBlob(sqlite3_value* param) {
        return sqlite3_value_type(param) == SQLITE_BLOB;
    }

    /// ֐ɓnꂽ̒lAƂĎ擾
    /**
     * @param param SQLiteFunction::onCall(), SQLiteAggregate::onStep() ɓnꂽ
     * @return 擾̒l
     */
    const char* getString(sqlite3_value* param) {
        return (const char*)sqlite3_value_text(param);
    }

    /// ֐ɓnꂽ̒lAƂĎ擾
    /**
     * @param param SQLiteFunction::onCall(), SQLiteAggregate::onStep() ɓnꂽ
     * @return 擾̒l
     */
    int getInt(sqlite3_value* param) {
        return sqlite3_value_int(param);
    }

    /// ֐ɓnꂽ̒lA64bitƂĎ擾
    /**
     * @param param SQLiteFunction::onCall(), SQLiteAggregate::onStep() ɓnꂽ
     * @return 擾̒l
     */
    long long getInt64(sqlite3_value* param) {
        return sqlite3_value_int64(param);
    }

    /// ֐ɓnꂽ̒lAƂĎ擾
    /**
     * @param param SQLiteFunction::onCall(), SQLiteAggregate::onStep() ɓnꂽ
     * @return 擾̒l
     */
    double getReal(sqlite3_value* param) {
        return sqlite3_value_double(param);
    }

    /// ֐ɓnꂽ̒lABLOBƂĎ擾
    /**
     * @param param SQLiteFunction::onCall(), SQLiteAggregate::onStep() ɓnꂽ
     * @return 擾̒l
     */
    const void* getBlob(sqlite3_value* param) {
        return sqlite3_value_blob(param);
    }

    /// ֐ɓnꂽ̃oCg擾
    /**
     * @param param SQLiteFunction::onCall(), SQLiteAggregate::onStep() ɓnꂽ
     * @return oCg
     * @note ̏ꍇAUTF8ƂẴoCgԂ
     */
    int getSize(sqlite3_value* param) {
        return sqlite3_value_bytes(param);
    }

    /// ֐ɓnꂽ̃oCg擾
    /**
     * @param param SQLiteFunction::onCall(), SQLiteAggregate::onStep() ɓnꂽ
     * @return 擾̒l
     * @note ̏ꍇAUTF16ƂẴoCgԂ
     */
    int getSize16(sqlite3_value* param) {
        return sqlite3_value_bytes16(param);
    }

    /// ֐̖߂liljZbg
    /**
     * ߂lNULLɃZbg
     */
    void setReturnNull() {
        sqlite3_result_null(ctx_);
    }

    /**
     * @param val ߂l
     */
    void setReturnInt(int val) {
        sqlite3_result_int(ctx_, val);
    }

    /// ֐̖߂li64bitljZbg
    /**
     * @param val ߂l
     */
    void setReturnInt64(long long val) {
        sqlite3_result_int64(ctx_, val);
    }

    /// ֐̖߂liljZbg
    /**
     * @param val ߂l
     */
    void setReturnReal(double val) {
        sqlite3_result_double(ctx_, val);
    }

    /// ֐̖߂lijZbg
    /**
     * @param val ߂l
     */
    void setReturnString(const char* val) {
        sqlite3_result_text(ctx_, val, (int)strlen(val), SQLITE_TRANSIENT);
    }

    /// ֐̖߂liBLOBjZbg
    /**
     * @param val ߂l
     * @param nBytes ߂l̃oCg
     * @param makeCopy val̃Rs[쐬Ė߂lƂꍇtrueA
     * val|C^̂܂ܖ߂ꍇfalse
     * @note makeCopyfalsȅꍇA֐ďoI
     * SQLŖ߂l𗘗pI܂ŁAval̎wĂ͂ȂȂB
     */
    void setReturnBlob(const void* val, int nBytes, bool makeCopy=true) {
        sqlite3_result_blob(ctx_, val, nBytes,
                            makeCopy ? SQLITE_TRANSIENT : SQLITE_STATIC);
    }
};

/// [U`֐쐬邽߂̃x[XNX
class SQLiteFunction : protected SQLiteFunctionBase {
public:
    /// RXgN^
    /**
     * @param db ֐o^SQLitef[^x[Xnh
     */
    SQLiteFunction(sqlite3* db) : SQLiteFunctionBase(db) {}

    virtual ~SQLiteFunction() {
        destroy();
    }

    /// o^[U`֐Ăяo鎞ɌĂ΂
    /**
     * @param argc argv̗vf
     * @param argv [U`֐ɓnꂽ̔z
     * @param userData create()ɓnuserDataƓ
     * @note ߂lԂ[U`֐̏ꍇÃ\bh߂O
     * SQLiteFunctionBase::setReturn()pĖ߂lZbgKvB
     */
    virtual void onCall(int argc, sqlite3_value** argv, void* userData) = 0;

    /// [U`֐SQLiteɓo^
    /**
     * @param funcName [U`֐(UTF-8)
     * @param nArgs [U`֐̎̐
     * @param userData [Uf[^
     */
    void create(const char* funcName, int numArgs, void* userData) {
        numArgs_ = numArgs;
        userData_ = userData;
        name_ = funcName;

        int res = sqlite3_create_function(db_, funcName, numArgs,
                                          SQLITE_UTF8, this, delegateCall,
                                          NULL, NULL);

        if(SQLITE_OK != res) {
            throw ConnectionException("Can't create function.");
        }
    }

    /// [U`֐̓o^
    void destroy() {
        if(!name_.empty()) {
            sqlite3_create_function(db_, name_.c_str(), numArgs_,
                                    SQLITE_UTF8, this, NULL,
                                    NULL, NULL);
        }
    }

protected:
    static void delegateCall(sqlite3_context *ctx,int	nArgs, sqlite3_value **params) {
        SQLiteFunction* pThis = reinterpret_cast<SQLiteFunction*>(sqlite3_user_data(ctx));
        pThis->ctx_ = ctx;
        pThis->onCall(nArgs, params, pThis->userData_);
    }
};


/// [U`AOQ[g쐬邽߂̃x[XNX
class SQLiteAggregate : protected SQLiteFunctionBase {
public:
    /// RXgN^
    /**
     * @param db AOQ[go^SQLitef[^x[Xnh
     */
    SQLiteAggregate(sqlite3* db) : SQLiteFunctionBase(db) {}

    virtual ~SQLiteAggregate() {
        destroy();
    }

    /// AOQ[ĝPXebvƂɌĂяo
    /**
     * @param argc argv̐
     * @param argv AOQ[gɗ^ꂽ̐
     * @param userData [Uf[^icreate()ɓnꂽ̂Ɠj
     */
    virtual void onStep(int argc, sqlite3_value **argv, void *userData) = 0;

    /// AOQ[g̍Ō̃XebvIɌĂ΂
    /**
     * @param userData icreate()ɓnꂽ̂Ɠj
     */
    virtual void onFinal(void* userData) = 0;

    /// AOQ[gSQLiteɓo^
    /**
     * @param funcName AOQ[g̖O
     * @param nArgs AOQ[g̎̐
     * @param userData onStep(), onFinal()ɓn[Uf[^
     */
    void create(const char* funcName, int numArgs, void* userData) {
        numArgs_ = numArgs;
        userData_ = userData;
        name_ = funcName;

        int res = sqlite3_create_function(db_, funcName, numArgs,
                                          SQLITE_UTF8, this, NULL,
                                          delegateStep, delegateFinal);

        if(SQLITE_OK != res) {
            throw ConnectionException("Can't create aggregate.");
        }
    }

    /// AOQ[g̓o^
    void destroy() {
        if(!name_.empty()) {
            sqlite3_create_function(db_, name_.c_str(),numArgs_,
                                    SQLITE_UTF8, this, NULL,
                                    NULL, NULL);
        }
    }

protected:
    /// gp
    static void delegateStep(sqlite3_context *ctx, int numArgs, sqlite3_value **params) {
        SQLiteAggregate* pThis = reinterpret_cast<SQLiteAggregate*>(sqlite3_user_data(ctx));
        pThis->onStep(numArgs, params, pThis->userData_);
    }

    /// gp
    static void delegateFinal(sqlite3_context *ctx) {
        SQLiteAggregate* pThis = reinterpret_cast<SQLiteAggregate*>(sqlite3_user_data(ctx));
        pThis->onFinal(pThis->userData_);
    }
};

/// [U`r֐쐬邽߂̃x[XNX
class SQLiteCollation {

protected:
    /// [U`r֐o^̃f[^x[Xnh
    sqlite3*			db_;
    /// r֐̖O(UTF8)
    std::string			name_;
    /// [Uf[^icreate()œnj
    void*			userData_;
    static int delegateCompare(void* userData, int nLen1,
                                const void* str1, int nLen2,
                                const void* str2) {
        SQLiteCollation* pThis = reinterpret_cast<SQLiteCollation*>(userData);

        std::string var1, var2;
        var1.assign((const char*)str1, (size_t)nLen1);
        var2.assign((const char*)str2, (size_t)nLen2);

        return pThis->onCompare( var1.c_str(), var2.c_str(), pThis->userData_);
    }


public:
    /// RXgN^
    /**
     * @param r֐o^̃f[^x[Xnh
     */
    SQLiteCollation(sqlite3* db) : db_(db) {
        userData_ = NULL;
    }

    virtual ~SQLiteCollation() {
        destroy();
    }

    /// rsxɌĂ΂BhNXŃI[o[ChB
    /**
     * @param var1 (UTF-8)
     * @param var2 (UTF-8)
     * @param userData create()ɓnuserDataƓ
     * @return var1var2菬ꍇ͕̒lA
     * var1var2傫ꍇ͐̒lA
     * var1var2ꍇ0ԂB
     */
    virtual int onCompare(const char* var1, const char*	var2, void* userData) = 0;

    /// r֐SQLiteɓo^
    /**
     * @param funcName ֐(UTF8)
     * @param userData onCompare()ɓn[Uf[^
     */
    void create(const char* funcName, void* userData) {
        userData_ = userData;
        name_ = funcName;
        sqlite3_create_collation(db_, funcName, SQLITE_UTF8, this, delegateCompare);
    }

    /// r֐̓o^
    void destroy() {
        if(!name_.empty()) {
            sqlite3_create_collation(db_, name_.c_str(), SQLITE_UTF8, this, NULL);
        }
    }

};


} // end of namespace sqlite3plus

#endif
