/**************************************************************
*
*  Feb. 23, 2005
*
*  The author disclaims copyright to this source code.
*  In place of a legal notice, here is a blessing:
*
*    May you do good and not evil.
*    May you find forgiveness for yourself and forgive others.
*    May you share freely, never taking more than you give.
*
**************************************************************/
#ifndef SQLITEPP_STATEMENT_H
#define SQLITEPP_STATEMENT_H

#include "SQLiteException.h"
#include <cstring>

namespace SQLite {

class SQLiteCursor {

    friend class SQLiteStatement;

    /// UgZbg̑SĂ̍s擾IƁAtrueɃZbg
    bool				eor_;
    /// ݂܂łɎ擾s̐
    int					rowNum_;
    /// 
    int					colNum_;
    sqlite3*				db_;
    sqlite3_stmt*			stmt_;

    SQLiteCursor(sqlite3_stmt* stmt, sqlite3* db) {
        db_ = db;
        stmt_ = stmt;
        rowNum_ = 0;
        eor_ = false;
        colNum_ = sqlite3_column_count(stmt_);
    }

    void checkResult(int rescode) {
        /*if(SQLITE_OK != rescode) {
            std::string msg("SQLiteCursor::checkResult() : ");
            msg.append(sqlite3_errmsg(db_));
            throw QueryException(msg.c_str(), rescode);
        }*/
    }

    void checkColIndex(int index, const char* what) {
        /*if(index < 0 || index >= colNum_) {
            throw QueryException(what, SQLITE_RANGE);
        }*/
    }

public:

    virtual ~SQLiteCursor() {}

    sqlite3* getDB() const {
        return db_;
    }

    sqlite3_stmt* getStmt() const {
        return stmt_;
    }

    /// UgZbg̑SĂ̍s擾IĂ邩ǂ𔻒
    /**
     * @return ȏ㌋ʍsȂtrueA܂݂false
     */
    bool getEor() {
        return eor_;
    }

    /// ݂܂łɎ擾sԂ
    /**
     * @return ݂܂łɎ擾s
     */
    int getRowNum() {
        return rowNum_;
    }

    /**
     * UgZbg̗񐔂Ԃ
     * @return 
     */
    int getColNum() {
        return colNum_;
    }

    /// ̍s擾
    /**
     * @return Ɏ̌ʍstrueAꂪŌ̍sȂfalse
     * @throw QueryException ʂ̎擾Ɏsꍇ
     */
    bool next() {
        int res = sqlite3_step(stmt_);

        if(SQLITE_ROW == res) {
            rowNum_++;
            return true;
        } else if(SQLITE_DONE == res) {
            eor_ = true;
            return false;
        } else {
            checkResult(res);
            return false;
        }
    }

    /// J[\ʒuďAUgZbg̐擪ɖ߂
    /**
     * @throw QueryException J[\̍ďɎsꍇ
     * @note SQLiteStatement::reset()Ɠ@\BǂsĂʂłB
     */
    void reset() {
        int res = sqlite3_reset(stmt_);
        checkResult(res);
    }

    /// ݃|CgĂs̎w̒lNULLǂ肷
    /**
     * @param index `FbN̔ԍi0n܂j
     * @return NULLȂtrueAłȂfalse
     * @throw QueryException index͈͂EĂꍇ
     */
    bool isNull(int index) {
        checkColIndex(index, "isNull");
        return (sqlite3_column_type(stmt_, index) == SQLITE_NULL);
    }

    /// ݃|CgĂs̎w̃^Cv񂩂ǂ肷
    /**
     * @param index `FbN̔ԍi0n܂j
     * @return ȂtrueAłȂfalse
     * @throw QueryException index͈͂EĂꍇ
     */
    bool isString(int index) {
        checkColIndex(index, "isString");
        return (sqlite3_column_type(stmt_, index) == SQLITE_TEXT);
    }

    /// ݃|CgĂs̎w̃^Cvǂ肷
    /**
     * @param index `FbN̔ԍi0n܂j
     * @return ȂtrueAłȂfalse
     * @throw QueryException index͈͂EĂꍇ
     */
    bool isInt(int index) {
        checkColIndex(index, "isInt");
        return (sqlite3_column_type(stmt_, index) == SQLITE_INTEGER);
    }

    /// ݃|CgĂs̎w̃^Cvǂ肷
    /**
     * @param index `FbN̔ԍi0n܂j
     * @return ȂtrueAłȂfalse
     * @throw QueryException index͈͂EĂꍇ
     */
    bool isReal(int index) {
        checkColIndex(index, "isReal");
        return (sqlite3_column_type(stmt_, index) == SQLITE_FLOAT);
    }

    /// ݃|CgĂs̎w̃^CvBLOBǂ肷
    /**
     * @param index `FbN̔ԍi0n܂j
     * @return BLOBȂtrueAłȂfalse
     * @throw QueryException index͈͂EĂꍇ
     */
    bool isBlob(int index) {
        checkColIndex(index, "isBlob");
        return (sqlite3_column_type(stmt_, index) == SQLITE_BLOB);
    }

    /// ݃|CgĂs̎w̒l𕶎ƂĎ擾
    /**
     * @param index ԍi0n܂j
     * @return 擾l
     * @throw QueryException index͈͂EĂꍇ
     */
    const char* getString(int index) {
        checkColIndex(index, "getString");
        return (const char*)sqlite3_column_text(stmt_, index);
    }

    /// ݃|CgĂs̎w̒l𐮐lƂĎ擾
    /**
     * @param index ԍi0n܂j
     * @return 擾l
     * @throw QueryException index͈͂EĂꍇ
     */
    int getInt(int index) {
        checkColIndex(index, "getInt");
        return sqlite3_column_int(stmt_, index);
    }

    /// ݃|CgĂs̎w̒l64bitlƂĎ擾
    /**
     * @param index ԍi0n܂j
     * @return 擾l
     * @throw QueryException index͈͂EĂꍇ
     */
    long long getInt64(int index) {
        checkColIndex(index, "getInt64");
        return sqlite3_column_int64(stmt_, index);
    }

    /// ݃|CgĂs̎w̒llƂĎ擾
    /**
     * @param index ԍi0n܂j
     * @return 擾l
     * @throw QueryException index͈͂EĂꍇ
     */
    double getReal(int index) {
        checkColIndex(index, "getReal");
        return sqlite3_column_double(stmt_, index);
    }

    /// BLOBl̐擪AhXԂ
    /**
     * @param index ԍi0n܂j
     * @return 擾AhX
     * @throw QueryException index͈͂EĂꍇ
     */
    const void* getBlob(int index) {
        checkColIndex(index, "getBlob");
        return sqlite3_column_blob(stmt_, index);
    }

    /// l߂oCgTCYԂB
    /**
     * @param index ԍi0n܂j
     * @return oCg
     * @throw QueryException index͈͂EĂꍇ
     * @note lłꍇAUTF8ɕϊɃoCgTCYZoB
     */
    int getSize(int index) {
        checkColIndex(index, "getSize");
        return sqlite3_column_bytes(stmt_, index);
    }

    /// l߂oCgTCYԂB
    /**
     * @param index ԍi0n܂j
     * @return oCg
     * @throw QueryException index͈͂EĂꍇ
     * @note lłꍇAUTF16ɕϊɃoCgTCYZoB
     */
    int getSize16(int index) {
        checkColIndex(index, "getSize16");
        return sqlite3_column_bytes16(stmt_, index);
    }

    /// w̖O擾
    /**
     * @param index ԍ (0n܂j
     * @return (UTF8)
     * @throw QueryException index͈͂EĂꍇ
     */
    const char* colName(int index) {
        checkColIndex(index, "colName");
        return sqlite3_column_name(stmt_, index);
    }

};


/// Xe[gg
class SQLiteStatement {

    friend class SQLiteConnection;

protected:
    std::string		sql_;
    sqlite3_stmt*	stmt_;
    sqlite3*		db_;
    /// RXgN^BSqliteConnection݂̂p
    /**
     * @param sql SQLBPrepared StatementƂėpꍇAChJ[h"?"܂߂邱Ƃ\B
     * @param stmt Xe[ggnh
     * @param db f[^x[Xnh
     */
    SQLiteStatement(const char* sql, sqlite3_stmt* stmt, sqlite3* db)
     : sql_(sql) , stmt_(stmt), db_(db) {}

    void checkResult(int rescode) {
        if(SQLITE_OK != rescode) {
            std::string msg("SQLiteStatement::checkResult() : ");
            msg.append(sqlite3_errmsg(db_));
            throw QueryException(msg.c_str(), rescode);
        }
    }

public:
    std::string getSQL() const {
        return sql_;
    }

    sqlite3_stmt* getStmt() const {
        return stmt_;
    }

    sqlite3* getDB() const {
        return db_;
    }

    virtual ~SQLiteStatement() {
        if(stmt_) {
            sqlite3_finalize(stmt_);
        }
    }

    /// xexecute, executeQueryXe[ggAĂexecuteł悤ɏԂZbg
    /**
     * @throw QueryException ZbgɎsꍇ
     * @note Prepared Statement̏ꍇAreset()ĂChJ[hɃoChꂽl͈ȑÔ܂܂łB
     * KvȂAreset()ɍăoCh邱ƂłB
     */
    void reset() {
        int res = sqlite3_reset(stmt_);
        checkResult(res);
    }

    /// prepared statement́Ałbindꂽp[^NAB
    /**
     * @throw QueryException p[^NAłȂꍇ
     */
    void clearParameters() {
        int res = sqlite3_clear_bindings(stmt_);
        checkResult(res);
    }

    /// ʂԂȂXe[ggsiINSERT, DELETE, UPDATE, CREATE TABLEȂǁj
    /**
     * @throw QueryException sɎsꍇ
     */
    void execute() {
        int res = sqlite3_step(stmt_);
        if (SQLITE_ROW  != res &&
                SQLITE_DONE != res) {
            checkResult(res);
        }
    }

    /// Xe[ggsAʂ擾邽߂̃J[\Ԃ
    /**
     * @return J[\IuWFNgւ̃|C^
     * @note ̎_ł͗O𓊂ȂBSQLiteCursor::next()œB
     */
    SQLiteCursor* executeQuery() {
        return new SQLiteCursor(stmt_, db_);
    }

    /// Prepared Statement̃ChJ[hɁANULLoCh
    /**
     * @param index CfbNXi0n܂j
     * @throw QueryException LȃCfbNX͈͂𒴉߂Ƃ
     * @note ŏ̃ChJ[h̃CfbNX́ASQLiteƈ0ł邱ƂɒӁB
     */
    void setNull(int index) {
        int res = sqlite3_bind_null(stmt_, index+1);
        checkResult(res);
    }

    /// Prepared Statement̃ChJ[hɁAۂ̒loCh
    /**
     * @param index CfbNXi0n܂j
     * @param val oChl
     * @throw QueryException LȃCfbNX͈͂𒴉߂Ƃ
     * @note ŏ̃ChJ[h̃CfbNX́ASQLiteƈ0ł邱ƂɒӁB
     */
    void setInt(int index, int val) {
        int res = sqlite3_bind_int(stmt_, index+1, val);
        checkResult(res);
    }

    /// Prepared Statement̃ChJ[hɁAۂ̒loCh
    /**
     * @param index CfbNXi0n܂j
     * @param val oChl
     * @throw QueryException LȃCfbNX͈͂𒴉߂Ƃ
     * @note ŏ̃ChJ[h̃CfbNX́ASQLiteƈ0ł邱ƂɒӁB
     */
    void setInt64(int index, long long val) {
        int res = sqlite3_bind_int64(stmt_, index+1, val);
        checkResult(res);
    }

    /// Prepared Statement̃ChJ[hɁAۂ̒loCh
    /**
     * @param index CfbNXi0n܂j
     * @param val oChl
     * @throw QueryException LȃCfbNX͈͂𒴉߂Ƃ
     * @note ŏ̃ChJ[h̃CfbNX́ASQLiteƈ0ł邱ƂɒӁB
     */
    void setReal(int index, double val) {
        int res = sqlite3_bind_double(stmt_, index+1, val);
        checkResult(res);
    }

    /// Prepared Statement̃ChJ[hɁAۂ̒loCh
    /**
     * @param index CfbNXi0n܂j
     * @param val oChl(UTF8)
     * @throw QueryException LȃCfbNX͈͂𒴉߂Ƃ
     * @note ŏ̃ChJ[h̃CfbNX́ASQLiteƈ0ł邱ƂɒӁB
     */
    void setString(int index, const char* val) {
        int res = sqlite3_bind_text(
                      stmt_, index+1, val,
                      (int)std::strlen(val),
                      SQLITE_TRANSIENT);

        checkResult(res);
    }

    /// Prepared Statement̃ChJ[hɁAۂ̒loCh
    /**
     * @param index CfbNXi0n܂j
     * @param val oChl
     * @param nBytes BLOB̃oCg
     * @param makeCopy BLOBRs[ĕێꍇɂtrue
     * @throw QueryException LȃCfbNX͈͂𒴉߂Ƃ
     * @note ŏ̃ChJ[h̃CfbNX́ASQLiteƈ0ł邱ƂɒӁB
     */
    void setBlob(int index, const void* val, int nBytes, bool makeCopy=true) {
        int res = sqlite3_bind_blob(stmt_, index+1, val, nBytes,
                                    makeCopy ? SQLITE_TRANSIENT : SQLITE_STATIC);

        checkResult(res);
    }

};


}


#endif

