/*
*   Translator.cpp
*
*   author  :   caprice ◆wx2.856/wgGo
*   comment :   This file written dat file's parser(I call "Coe parser engine") class.
*               But this class soon change to new parser(see "ch2parser.hpp").
*               So, you haven't use it.
*/

#include <iostream>
#include <string>
#include <wx/textfile.h>
#include <wx/variant.h>

// Coe version 0.01

#include <wx/regex.h>
#include <wx/msgdlg.h>
#include "IO.Coe.Translator.h"

using namespace std;

namespace BBS{
    namespace Coe{
        wxString Translator::getTitle(const wxString& text){
            size_t begin = text.rfind(_T("<>"));
            size_t end = text.find(_T("\n"));
            Title = text.Mid(begin + 2, end);
            return Title;
        }

        wxString& Translator::Dat2Html(const wxString& Path, wxString& Result){
            wxTextFile ifs(Path);
            ifs.Open(wxConvLocal);
            bool FirstLine = true;
            Result = _T("<html> \n"
                        "<head> \n"
                    #ifdef __WINDOWS__
                        "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-16\"> \n"
                    #else
                        "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-32\"> \n"
                    #endif
                        "<title>");
            wxRegEx escapeResAnchor(_T("(<a href=\"\\.\\./test/read.cgi/([a-z]+)/([0-9]+)/([0-9]+)\" target=\"_blank\">&gt;&gt;([0-9]+)</a>+)"));
            int idx = 1;
            for(wxString text = ifs.GetFirstLine(); !(ifs.Eof()); text = ifs.GetNextLine()){
                if(FirstLine){
                    getTitle(text);
                    // 手抜き
                    text.Replace(Title.c_str(), _T(""), false);

                    Result += Title;
                    Result += _T("</title> \n"
                                 "</head>  \n"
                                 "<body>   \n");
                    FirstLine = false;
                }
                /*
                1行wxString& text目：名前<>メール<>日付 ID BE-ID<>本文<>スレッドタイトル
                2行目：名前<>メール<>日付 ID BE-ID<>本文<>
                例   ：名無しさん<>sage    <>2008/12/12(金) 17:28:35 ID:???<> テスト <>テストスレ
                       ^Loc_Name   ^Loc_Mail ^Loc_Date_ID                    ^Loc_Text ^Loc_Title
                */
                size_t i = 0;
                text.Replace(_T("</b>"), _T(""));
                text.Replace(_T("<b>"), _T(""));
                escapeResAnchor.Replace(&text, _T(""));
                i = text.find(_T("<>"), 0);
                for(int j = 0; j < 5; j++){
                    switch(j){
                        case 0: // for name
                        {
                            wxVariant idxConv(static_cast<long>(idx));
                            const static wxString fontTagBegin(_T("<b><font color=\"#006600\">"));
                            const static wxString fontTagEnd(_T("</font></b>"));
                            wxString idxStr;
                            text.insert(i + 2, _T("["));
                            text.insert(i, fontTagEnd);
                            text.insert(0, fontTagBegin);
                            idxConv.Convert(&idxStr);
                            idxStr += _T(": ");
                            text.insert(0, idxStr);
                            // <b><font color="#00FF00"></font></b>のぶん。
                            LocMail = i + 38;
                            LocMail = i + fontTagBegin.Len() + fontTagEnd.Len() + idxStr.Len();
                            i = text.find(_T("<>"), LocMail);
                            break;
                        }

                        case 1: // for mail
                        {
                            text.insert(i, _T("]"));
                            LocDate_ID = i + 2;
                            i = text.find(_T("<>"), LocDate_ID);
                            break;
                        }

                        case 2: // for date & ID
                        {
                            LocText = i + 2;
                            text.insert(i, _T("<br>"));
                            i = text.find(_T("<>"), LocText);
                            break;
                        }

                        case 3: // for text
                        {
                            LocTitle = i + 2;
                            setUrlLink(text);
                            // i = text.find(_T("<>"), LocTitle);
                            break;
                        }

                        case 4: // for title
                        {
                            text.insert(text.rfind(_T("<>")), _T("<br><br>"));
                            break;
                        }
                    }
                }
                text.Replace(_T("<>"), _T(" "));
                Result += text;
                ++idx;
            }
            Result += _T("</body> \n"
                         "</html> \n");
            return Title;
        }

        void Translator::setUrlLink(wxString& text) {
            size_t loc = text.find(_T("://"));
            while(loc != wxString::npos) {
                wxString hrefTagBefore, hrefTagAfter = _T("</a>");
                size_t locBeginUrl;
                if(text.find(_T("ttp://")) != wxString::npos) {
                    if(text.find(_T("http"), loc - 5) != wxString::npos || text.find(_T("https")) != wxString::npos) {
                        hrefTagBefore = _T("<a href=\"");
                        locBeginUrl = text.find(_T("http"), loc - 5);
                    }else if(text.find(_T("ttps"), loc -5) != wxString::npos || text.find(_T("ttp")) != wxString::npos) {
                        hrefTagBefore = _T("<a href=\"h");
                        locBeginUrl = text.find(_T("ttp"), loc - 5);
                    }
                }else{
                    hrefTagBefore = _T("<a href=\"");
                }
                wxString fontTagBefore = _T("<font color=\""),
                         fontTagAfter = _T("</font>"),
                         linkedUrl = text.Mid(locBeginUrl, text.find(_T("<br>"), locBeginUrl) - locBeginUrl - 1),
                         resultTag;
                switch (judgeUrlType(linkedUrl)) {
                	case CH2:
                		fontTagBefore += _T("#663333\">");
                		break;
                    case PICTURE:
                        fontTagBefore += _T("#CC6600\">");
                        break;
                    case VIDEO:
                        fontTagBefore += _T("#FF3300\">");
                        break;
                    case MUSIC:
                        break;
                    case NORMAL:
                        fontTagBefore.Clear();
                        fontTagAfter.Clear();
                        break;
                }
                resultTag = hrefTagBefore + linkedUrl + _T("\">") + fontTagBefore +
                            linkedUrl + fontTagAfter + hrefTagAfter;
                text.Replace(linkedUrl.c_str(), resultTag.c_str());
                loc = text.find(_T("://"), text.rfind(_T("</a>")));
            }
        }

        LinkTo Translator::judgeUrlType(const wxString& url) {
            if(url.find(_T(".2ch.net/test/read.cgi/")) != wxString::npos) {
                return CH2;
            }
            // 短絡評価されるせいで"||"が使えない･･･
            if(url.find(_T("youtu.be/")) != wxString::npos) {
                return VIDEO;
            }else if(url.find(_T("www.youtube.com/watch?v=")) != wxString::npos) {
                return VIDEO;
            }else if(url.find(_T(".nikovideo.jp/watch/")) != wxString::npos) {
                return VIDEO;
            }

            if(url.find(_T(".jpg")) != wxString::npos) {
                return PICTURE;
            }else if(url.find(_T(".png")) != wxString::npos) {
                return PICTURE;
            }else if(url.find(_T(".gif")) != wxString::npos) {
                return PICTURE;
            }else if(url.find(_T(".tif")) != wxString::npos) {
                return PICTURE;
            }else if(url.find(_T(".tiff")) != wxString::npos) {
                return PICTURE;
            }
            return NORMAL;
        }
    }
}
