#include <vector>
#include <map>

#include <wx/string.h>
#include <wx/textfile.h>
#include <wx/datetime.h>
#include <wx/variant.h>
#include <wx/filename.h>
#include <wx/msgdlg.h>

#include "Mgr2ch.h"
#include "Connect2ch.h"
#include "Header4Channel2.h"
#include "IO.ListMaker.BoardListMaker.h"
#include "IO.ListMaker.ThreadListMaker.h"
#include "IO.Coe.Translator.h"

using namespace std;

namespace BBS {

using namespace ListMaker;
using namespace Coe;

    pair<wstring, wstring> Mgr2ch::getThread(const AddressData& Info, bool isLocal){
        if(!isLocal) {
            Mgr = new TCP_IP::Connect2ch(Info, userAgent);
            TCP_IP::ContentsInfo cInfo = Mgr->getThread();
            if(cInfo.isSuccess == 200) {
                // ここから
                wxString temp = Info.ThreadKey.Mid(0, 4);
                DirName = _T("Log\\2ch.net\\") + Info.BoardKey + _T("\\") + temp + _T("\\") + Info.ThreadKey + _T(".dat");
                // ここまで
                Translator datConverter;
                title_and_text.first    = datConverter.Dat2Html(DirName, text).c_str();
                title_and_text.second   = text.c_str();
                wxString size;
                wxVariant val((long)title_and_text.second.size());
                val.Convert(&size);
                db->openDB(_T("Log\\2ch.net\\") + Info.BoardKey + _T("\\log_idx.db"));
                db->createThreadTable();
                db->entry2ThreadTable(Info.ThreadKey, title_and_text.first,
                                     Info.ThreadKey, cInfo.lastModefied,
                                     cInfo.eTag, size);
            } else {
                wxMessageBox(_T("通信えらー！再試行してくだはい。。。"), _T("えらー"));
                text = _T("<html>                           "
                          "<body>                           "
                          "ダウソできませんですた。。。<br> "
                          "(´・ω・`)ｽﾏｿ                   "
                          "</body>                          "
                          "</html>");
                title_and_text.first    = _T("ダウソできませんですた。。。");
                title_and_text.second   = text.c_str();
            }
            delete Mgr;
        }else{
            // ここから
            wxString temp = Info.ThreadKey.Mid(0, 4);
            DirName = _T("Log\\2ch.net\\") + Info.BoardKey + _T("\\") + temp + _T("\\") + Info.ThreadKey + _T(".dat");
            // ここまで
            Translator datConverter;
            title_and_text.first    = datConverter.Dat2Html(DirName, text).c_str();
            title_and_text.second   = text.c_str();
        }
        return title_and_text;
    }

    vector<ThreadInfo> Mgr2ch::getTList(const AddressData& Info, bool isLocal){
        if(!isLocal) {
            ListMaker::BoardListMaker brdMaker;
            wxString brdJpName = brdMaker.searchBoardNameFromBoardKey(_T("2ch.brd"), Info.BoardKey);
            Mgr = new TCP_IP::Connect2ch(Info, userAgent);
            try {
                TCP_IP::ContentsInfo cInfo = Mgr->getThreadList();
                if(cInfo.isSuccess == 200) {
                    // ここから
                    wxString path2Subject = _T("Log\\2ch.net\\") + Info.BoardKey + _T("\\subject.txt");
                    // ここまで
                    wxFileName fileName(path2Subject);
                    wxString size = fileName.GetSize().ToString();
                    db->openDB(_T("Log\\2ch.net\\") + Info.BoardKey + _T("\\log_idx.db"));
                    db->createThreadListTable();
                    db->entry2ThreadListTable(brdJpName, Info.HostKey,
                                             Info.BoardKey, cInfo.lastModefied,
                                             cInfo.eTag, size);
                } else {
                    wxMessageBox(_T("通信えらー！再試行してくだはい。。。"), _T("えらー"));
                }
            } catch(TCP_IP::HostChangeException& ce) {
                ce.what();
                ListMaker::BoardListMaker brdMaker;
                brdMaker.changeHostName(_T("2ch.brd"), ce.getOldHostName(), ce.getNewHostName());
                wxString msg = "板の移行が完了しました。\n";
                msg = "old hostname : " + ce.getOldHostName() + _T("\n");
                msg = "new hostname : " + ce.getNewHostName();
                wxMessageBox(msg, _T(""));
            }
            delete Mgr;
        }
        ListMaker::ThreadListMaker TLMaker;
        // ここから
        DirName = _T("Log\\2ch.net\\") + Info.BoardKey + _T("\\subject.txt");
        // ここまで
        return TLMaker.MakeList(DirName);
    }

    vector< vector<BoardInfo> > Mgr2ch::getBoardList(const AddressData& Info, bool isLocal){
        ListMaker::BoardListMaker BLMaker;
        DirName = _T("2ch.brd");
        if(!isLocal) {
            Mgr = new TCP_IP::Connect2ch(Info, userAgent);
            TCP_IP::ContentsInfo cInfo = Mgr->getBoardList();
            if(cInfo.isSuccess == 200) {
                delete Mgr;
                BLMaker.makeList(DirName);
            } else {
                wxMessageBox(_T("通信えらー！再試行してくだはい。。。"), _T("えらー"));
            }
        }
        return BLMaker.read(DirName);
    }

    int Mgr2ch::postResponse(const AddressData& Info, const wxString& postedStr){
        Mgr = new TCP_IP::Connect2ch(Info);
        delete Mgr;
        return 0;
    }

    int Mgr2ch::makeThread(const AddressData& Info, const wxString& postedStr) {
        Mgr = new TCP_IP::Connect2ch(Info);
        delete Mgr;
        return 0;
    }

} // namespace BBS

