#include "SQLMgr.h"

#include <exception>
#include <vector>
#include <algorithm>

#include <wx/msgdlg.h>
#include <wx/filefn.h>

namespace SQLite {
/// TODO (caprice#1#): *dbをキャッシュするようにする
    SQLMgr::SQLMgr() {
        db = new SQLiteConnection();
    }

    SQLMgr::~SQLMgr() {
        delete db;
    }

    void SQLMgr::createThreadListTable() {
        if(!isAlreadyCreatedTable("ThreadListTable")) {
            execStmt("CREATE TABLE ThreadListTable"
                     "(name TEXT NOT NULL, hostKey TEXT NOT NULL,"
                     " boardKey TEXT NOT NULL, last_mod TEXT NOT NULL,"
                     " eTag TEXT NOT NULL, size TEXT NOT NULL);");
        }
    }

    void SQLMgr::createThreadTable() {
        if(!isAlreadyCreatedTable("ThreadTable")) {
            execStmt("CREATE TABLE ThreadTable"
                     "(threadId  TEXT NOT NULL, name TEXT NOT NULL, "
                     " threadKey TEXT NOT NULL, last_mod TEXT NOT NULL,"
                     " eTag TEXT NOT NULL, size      TEXT NOT NULL);");
        }
    }

    bool SQLMgr::deleteFromThreadListTable() {
        ;
    }

    bool SQLMgr::deleteFromThreadTable(const wxString& threadId, const wxString& threadName) {
        try {
            SQLiteStatement *stmt = db->createStatement("DROP TABLE ThreadTable;");
            stmt->execute();
            SQLiteStatement *stmt2 = db->createStatement("VACUUM;");
            stmt2->execute();
            SQLiteStatement *stmt3 = db->createStatement("REINDEX;");
            stmt3->execute();
            delete stmt;
            delete stmt2;
            delete stmt3;
        } catch(...) {
            return false;
        }
        return true;
    }

    bool SQLMgr::entry2ThreadListTable(const wxString& boardName, const wxString& hostKey,
                                       const wxString& boardKey, const wxString& last_mod_time,
                                       const wxString& eTag, const wxString& size) {
        try {
            SQLiteStatement *stmt = db->createStatement("INSERT INTO ThreadListTable VALUES(?, ?, ?, ?, ?, ?);");
            stmt->setString(0, (const char*)boardName.ToUTF8());
            stmt->setString(1, (const char*)hostKey.ToUTF8());
            stmt->setString(2, (const char*)boardKey.ToUTF8());
            stmt->setString(3, (const char*)last_mod_time.ToUTF8());
            stmt->setString(4, (const char*)eTag.ToUTF8());
            stmt->setString(5, (const char*)size.ToUTF8());
            stmt->execute();
            delete stmt;
        } catch(...) {
            return false;
        }
        return true;
    }

    bool SQLMgr::entry2ThreadTable(const wxString& threadId, const wxString& threadName,
                                   const wxString& threadKey, const wxString& last_mod_time,
                                   const wxString& eTag, const wxString& size) {
        try {
            SQLiteStatement *stmt = db->createStatement("INSERT INTO ThreadTable VALUES(?, ?, ?, ?, ?, ?);");
            stmt->setString(0, (const char*)threadId.ToUTF8());
            stmt->setString(1, (const char*)threadName.ToUTF8());
            stmt->setString(2, (const char*)threadKey.ToUTF8());
            stmt->setString(3, (const char*)last_mod_time.ToUTF8());
            stmt->setString(4, (const char*)eTag.ToUTF8());
            stmt->setString(5, (const char*)size.ToUTF8());
            stmt->execute();
            delete stmt;
        } catch(...) {
            return false;
        }
        return true;
    }

    bool SQLMgr::getLastModTimeAndSizeFromThreadListTable() {
        ;
    }

    bool SQLMgr::getLastModTimeAndSizeFromThreadTable(const wxString& threadId, const wxString& threadName) {
        ;
    }

    int SQLMgr::isExistItem(const char *table_name, const char *name) {
        char sql[128] = "SELECT * FROM ";
        std::strcat(sql, table_name);
        SQLiteStatement *stmt = db->createStatement(sql);
        SQLiteCursor *cur = stmt->executeQuery();
        while(cur->next()) {
            if(!std::strcmp(table_name, cur->getString(1))) {
                delete cur;
                delete stmt;
                return cur->getInt(0);
            }
        }
        delete cur;
        delete stmt;
        return 0;
    }

    bool SQLMgr::isAlreadyCreatedTable(const char *table_name) {
        return wxFileExists(dbPath);
    }
}

