#ifndef TWITTER_HPP_INCLUDED
#define TWITTER_HPP_INCLUDED

#include "libtwitter.hpp"

namespace twitter {
    enum OAuthType {
        OAUTH,
        xAUTH
    };

    class Connecter {
        public:
            Connecter(OAuthType type = xAUTH,
                      const String& consumerKey = oAuth::conumerKey,
                      const String& consumerSecret = oAuth::conumerSecretKey) :
                        connectType(type),
                        key(consumerKey),
                        secretKey(consumerSecret) {}
            virtual ~Connecter() {}
            bool isConnect() { return isConnect_; }
        private:
            typedef
                #if defined(USE_BOOST)
                    boost::asio::ip::tcp::iostream
                #elif defiend(USE_CLX)
                    clx::tcp::socket
                #else
                    wxHTTP
                #endif
                    Socket;
            #ifdef defined(USE_WX)
                inline wxSocketBase& operator<<(wxSocketBase& sock, const wxString& headers) {
                    const wxWX2MBbuf cbuf = headers.mb_str();
                    sock.Write(cbuf, strlen(cbuf));
                    return sock;
                }
            #endif
            void connect();
            Connector& operator=(const Connecter& con) {}
            Connector(const Connecter& con) {}
            std::vector<String> header;
            bool isConnect_;
            OAuthType
    };

    namespace api {
        class getUserTimeLine {
            operator()(const Connector& con) {
                con << ;
            }
        }
    }
}

#endif // TWITTER_HPP_INCLUDED
