#include <wx/msgdlg.h>
#include "XmlMgr.h"

/*
*   <config>
*       <abone id="1" val="true"/>
*       ...
*   </config>
*/

namespace Config {

bool XmlMgr::write(const wxString& itemName, long id, const wxString& value) {
    wxXmlNode *children = xml->getRoot()->GetChildren();
    for(wxXmlNode *node = children->GetNext(); node; node = node->GetNext()) {
        if(node->GetName() == itemName) {
            if(node->GetPropVal(_T("id"), wxEmptyString) == long2str(id)) {
                node->GetProperties()->GetNext()->SetValue(value);
                return true;
            }else{
                wxMessageBox(_T(".config.xmlが壊れてます。。。\n")
                             _T("func     : ConfigMgr::write()\n")
                             _T("file     : .config.xml\n")
                             _T("ItemName : ") + itemName + _T("\n"),
                             _T("えらー"));
                return false;
            }
        }
    }
    children->SetNext(new wxXmlNode(xml->getRoot(), wxXML_ELEMENT_NODE,
                                    itemName, wxEmptyString,
                                    new wxXmlProperty(_T("id"), long2str(id),
                                                     new wxXmlProperty(_T("val"), value))));
    return true;
}

wxString XmlMgr::read(const wxString& itemName, long key) {
    wxXmlNode *children = xml->getRoot()->GetChildren();
    for(wxXmlNode *node = children->GetNext(); !node; node = node->GetNext()) {
        if(node->GetName() == itemName) {
            if(node->GetPropVal(_T("id"), wxEmptyString) == long2str(key)) {
                return node->GetPropVal(_T("val"), wxEmptyString);
            }
        }
    }
    return wxEmptyString;
}

wxString XmlMgr::read(long key) {
    wxXmlNode *children = xml->getRoot()->GetChildren();
    for(wxXmlNode *node = children->GetNext(); !node; node = node->GetNext()) {
        if(node->GetPropVal(_T("id"), wxEmptyString) == long2str(key)) {
            return node->GetPropVal(_T("val"), wxEmptyString);
        }
    }
    return wxEmptyString;
}

gmConfig *XmlMgr::loadConfig() {
    long i = 1;
    for(wxString val = read(i); val != wxEmptyString; i++) {
        //g_ConfigTable[i] = val;
    }
    return NULL;
}

bool XmlMgr::setConfig(const gmConfig *conf) {
    return false;
}

}

