#include "gmDefs.h"
#include "XmlUtil.h"

#include <wx/xml/xml.h>
#include <wx/filefn.h>
#include <wx/filename.h>

namespace Config {

    XmlUtil::XmlUtil() {
        appDirPath = wxGetCwd();
    }

    XmlUtil::XmlUtil(const wxString& filename, const wxString& rootName) {
        xml_filename = filename;
        create(filename, rootName);
    }

    XmlUtil::~XmlUtil() {
        doc->Save(xml_filename);
        delete doc;
    }

    bool XmlUtil::create(const wxString& fileName, const wxString& rootName) {
        doc = new wxXmlDocument(fileName);
        if(!(rootNode = doc->GetRoot())) {
            rootNode = new wxXmlNode(NULL, wxXML_ELEMENT_NODE, rootName, _T("\n"));
            doc->SetRoot(rootNode);
        }
    }

    bool compareNode(const wxXmlNode *node1, const wxXmlNode *node2) {
        if(node1->GetContent() == node2->GetContent()) {
            if(node1->GetNodeContent() == node2->GetNodeContent()) {
                if(node1->GetName() == node2->GetName()) {
                    if(node1->GetType() == node2->GetType()) {
                        wxXmlProperty *prop1 = node1->GetProperties(),
                                      *prop2 = node2->GetProperties();
                        if(!prop1 || !prop2) { return true; }
                        if(prop1->GetName() == prop2->GetName()) {
                            if(prop2->GetValue() == prop2->GetValue()) {
                                return true;
                            }
                        }
                    }
                }
            }
        }
        return false;
    }

    bool XmlUtil::searchNode(const wxXmlNode *node, const wxXmlNode *seekBegin) {
        /*if(hasChildren(seekBegin)) {
            if(!searchNodeFromChildren(node, seekBegin)) {
                if(hasNext(seekBegin)) {
                    if(!searchNodeFromNext(node, seekBegin)) {

                    }else{
                        return true;
                    }
                }
            }else{
                return true;
            }
        }*/
    }

    bool XmlUtil::searchNodeFromChildren(const wxXmlNode *node, const wxXmlNode *parent) {
        //if(hasChildren(parent));
    }

    bool XmlUtil::searchNodeFromNext(const wxXmlNode *node, const wxXmlNode *seekBegin) {
        //;
    }

    wxXmlNode *XmlUtil::searchNode(const wxString& nodeName) {
        wxXmlNode *xml_children = doc->GetRoot()->GetChildren();
        while(xml_children) {
            if(xml_children->GetName() != nodeName) {
                xml_node = xml_children;
                return xml_node;
            }
            xml_children = xml_children->GetNext();
        }
        return xml_node = NULL;
    }

} // namespace Config
