/**
*   Name:      GikoMonaApp.cpp
*   Purpose:   Code for Application Class
*   Author:    caprice ◆wx2.856/wgGo
*   Created:   2009-08-05
*   Copyright:  (C) 2009-2010 caprice, All right reserved.
*   License:   BSD License
*/

#include "gmDefs.h"

#include "GikoMonaApp.h"
#include "XmlUtil.h"
#include "gmGuiMgr.h"

//(*AppHeaders
#include "GikoMonaMain.h"
#include <wx/image.h>
//*)

#include <wx/socket.h>
#include <wx/msgdlg.h>
#include <wx/cmdline.h>
#include <wx/artprov.h>
#include <wx/bitmap.h>

#include <vector>
#include <iostream>
#include <fstream>

using namespace std;

IMPLEMENT_APP(GikoMonaApp);

bool GikoMonaApp::OnInit()
{
    //(*AppInitialize
    bool wxsOK = true;
    wxInitAllImageHandlers();
    wxSocketBase::Initialize();

    if(argc > 1) {
        wxCmdLineParser cmdParser(argc, argv);
        cmdParser.EnableLongOptions(true);
        const static wxCmdLineEntryDesc cmdLineDesc[] = {
            { wxCMD_LINE_SWITCH, _T("l"), _T("print-log"),      NULL },
            { wxCMD_LINE_SWITCH, _T("p"), _T("enable-plugin"),  NULL },
            { wxCMD_LINE_SWITCH, _T("t"), _T("enable-store-in-taskbar"),  NULL },
            { wxCMD_LINE_SWITCH, NULL,    _T("detsu"),  NULL },

            { wxCMD_LINE_OPTION, NULL,    _T("enable-for-dev"), NULL },

            { wxCMD_LINE_PARAM,  NULL,    NULL,                 NULL, wxCMD_LINE_VAL_STRING,
              wxCMD_LINE_NEEDS_SEPARATOR | wxCMD_LINE_VAL_STRING },

            { wxCMD_LINE_NONE }
        };

        cmdParser.SetDesc(cmdLineDesc);
        if(cmdParser.Parse(false)) {
            wxMessageBox(_("不正な引数です。。。"), _T("えらー"));
            wxsOK = false;
        } else {
            wxString val;
            if(cmdParser.Found(_T("l")) || cmdParser.Found(_T("print-log"))) {
            #ifndef __WXDEBUG__
                wxGetApp().gmLog.init();
            #endif // !__WXDEBUG__
            } else if(cmdParser.Found(_T("detsu"))) {
                wxMessageBox(_T("でつ\n亡きDuawinのｻｸｰｼｬﾀﾝへの追悼の意を込めて..."));
            } else if(cmdParser.Found(_T("enable-for-dev"), &val)) {
                if(val == _T("debug")) {
                    //...
                } else if(val == _T("speed-test")) {
                    //...
                }
            }
        }
    }

#ifdef __WXDEBUG__
    wxGetApp().gmLog.init();
#endif // __WXDEBUG__

    wxsOK = initIcons();
    if ( wxsOK ) {
    	gmGuiMgr *mgr = new gmGuiMgr;
    	mgr->createMainWindow(0);
    	mgr->showMainWindow();
    	SetTopWindow(mgr->getMainWindow());
    }
    //*)
    return wxsOK;
}

int GikoMonaApp::OnExit(){
    //(*AppInitialize
    //delete m_checker;
    //*)
    #ifdef __WXDEBUG__
        wxGetApp().gmLog.done();
    #endif // __WXDEBUG__
    return 0;
}
