/***************************************************************
 * Name:      GikoMonaMain.cpp
 * Purpose:   Code for Application Frame
 * Author:     ()
 * Created:   2009-08-05
 * Copyright:  ()
 * License:
 **************************************************************/

#include "gmDefs.h"

#include <utility>
#include <vector>
#include <algorithm>

#include <wx/filefn.h>
#include <wx/filename.h>
#include <wx/msgdlg.h>
#include <wx/aboutdlg.h>
#include <wx/textfile.h>
#include <wx/regex.h>
#include <wx/xml/xml.h>
#include <wx/uri.h>
#include <wx/thread.h>
#include <wx/filename.h>
#include <wx/stdpaths.h>

//独自定義ヘッダ
#include "GikoMonaApp.h"
#include "GikoMonaMain.h"
#include "BbsMgr.h"
#include "Mgr2ch.h"
#include "gmControls.h"
#include "IO.ListMaker.ThreadListMaker.h"
#include "IO.Lua.h"

//(*InternalHeaders(GikoMonaFrame)
#include <wx/intl.h>
#include <wx/string.h>
//*)

using namespace std;

TVWindow *TVWnd;
bool isOpenedTVWindow;

//(*IdInit(GikoMonaFrame)
const long GikoMonaFrame::ID_TREECTRL1 = wxNewId();
const long GikoMonaFrame::ID_PANEL5 = wxNewId();
const long GikoMonaFrame::ID_TREECTRL2 = wxNewId();
const long GikoMonaFrame::ID_PANEL6 = wxNewId();
const long GikoMonaFrame::ID_TREECTRL3 = wxNewId();
const long GikoMonaFrame::ID_PANEL7 = wxNewId();
const long GikoMonaFrame::ID_TREECTRL4 = wxNewId();
const long GikoMonaFrame::ID_PANEL8 = wxNewId();
const long GikoMonaFrame::ID_NOTEBOOK2 = wxNewId();
const long GikoMonaFrame::ID_PANEL2 = wxNewId();
const long GikoMonaFrame::ID_TREECTRL5 = wxNewId();
const long GikoMonaFrame::ID_PANEL3 = wxNewId();
const long GikoMonaFrame::ID_TREECTRL6 = wxNewId();
const long GikoMonaFrame::ID_PANEL4 = wxNewId();
const long GikoMonaFrame::ID_NOTEBOOK1 = wxNewId();
const long GikoMonaFrame::ID_PANEL9 = wxNewId();
const long GikoMonaFrame::ID_NOTEBOOK3 = wxNewId();
const long GikoMonaFrame::ID_PANEL1 = wxNewId();
const long GikoMonaFrame::ID_SPLITTERWINDOW1 = wxNewId();
const long GikoMonaFrame::ID_Main_Menu_File_OpenTV = wxNewId();
const long GikoMonaFrame::ID_Main_Menu_File_Import = wxNewId();
const long GikoMonaFrame::ID_Main_Menu_File_Export = wxNewId();
const long GikoMonaFrame::ID_Main_Menu_File_Quit = wxNewId();
const long GikoMonaFrame::ID_Main_Menu_Board_Renewal = wxNewId();
const long GikoMonaFrame::ID_Main_Menu_ThreadList_Renewal = wxNewId();
const long GikoMonaFrame::ID_Main_Menu_Search_Thread = wxNewId();
const long GikoMonaFrame::ID_Main_Menu_Search_Board = wxNewId();
const long GikoMonaFrame::ID_Main_Menu_Search_Option_Enable_Regex = wxNewId();
const long GikoMonaFrame::ID_Main_Menu_Search_Option = wxNewId();
const long GikoMonaFrame::ID_Main_Menu_Setting_Set = wxNewId();
const long GikoMonaFrame::ID_Main_Menu_Help_ShowReleaseNote = wxNewId();
const long GikoMonaFrame::ID_Main_Menu_Help_About = wxNewId();
const long GikoMonaFrame::ID_STATUSBAR1 = wxNewId();
//*)

BEGIN_EVENT_TABLE(GikoMonaFrame,wxFrame)
//(*EventTable(GikoMonaFrame)
    EVT_MENU(ID_Main_Menu_File_OpenTV, GikoMonaFrame::OnMenuOpenTVClick)
    EVT_MENU(ID_Main_Menu_File_Quit, GikoMonaFrame::OnQuit)
    EVT_MENU(ID_Main_Menu_Board_Renewal, GikoMonaFrame::OnMenuBoardListRenewalClick)
    EVT_MENU(ID_Main_Menu_Setting_Set, GikoMonaFrame::OnMenuSettingClick)
    EVT_MENU(ID_Main_Menu_Help_ShowReleaseNote, GikoMonaFrame::OnMenuShowReleaseNoteClick)
    EVT_MENU(ID_Main_Menu_Help_About, GikoMonaFrame::OnAbout)
//*)
    EVT_CLOSE(GikoMonaFrame::OnCloseWindow)
END_EVENT_TABLE()

GikoMonaFrame::GikoMonaFrame(gmGuiMgr* gui, wxWindow* parent,wxWindowID id) {
    guiMgr = gui;

//(*Initialize(GikoMonaFrame)
    Create(parent, wxID_ANY, _("板＆スレッドリスト - GikoMona"), wxDefaultPosition, wxDefaultSize, wxDEFAULT_FRAME_STYLE, _T("wxID_ANY"));
    SetClientSize(wxSize(900,673));
    Panel1 = new wxPanel(this, ID_PANEL1, wxPoint(96,320), wxSize(900,664), wxTAB_TRAVERSAL, _T("ID_PANEL1"));
    BoxSizer1 = new wxBoxSizer(wxHORIZONTAL);
    SplitterWindow1 = new wxSplitterWindow(Panel1, ID_SPLITTERWINDOW1, wxDefaultPosition, wxSize(890,659), wxSP_3D, _T("ID_SPLITTERWINDOW1"));
    SplitterWindow1->SetMinimumPaneSize(-30);
    Notebook1 = new wxNotebook(SplitterWindow1, ID_NOTEBOOK1, wxPoint(8,48), wxSize(256,576), 0, _T("ID_NOTEBOOK1"));
    Panel2 = new wxPanel(Notebook1, ID_PANEL2, wxDefaultPosition, wxDefaultSize, wxTAB_TRAVERSAL, _T("ID_PANEL2"));
    BoxSizer2 = new wxBoxSizer(wxHORIZONTAL);
    Notebook2 = new wxNotebook(Panel2, ID_NOTEBOOK2, wxPoint(8,8), wxSize(232,536), 0, _T("ID_NOTEBOOK2"));
    Panel5 = new wxPanel(Notebook2, ID_PANEL5, wxDefaultPosition, wxDefaultSize, wxTAB_TRAVERSAL, _T("ID_PANEL5"));
    BoxSizer5 = new wxBoxSizer(wxHORIZONTAL);
    TreeCtrl1 = new wxTreeCtrl(Panel5, ID_TREECTRL1, wxPoint(8,8), wxSize(208,496), wxTR_DEFAULT_STYLE, wxDefaultValidator, _T("ID_TREECTRL1"));
    BoxSizer5->Add(TreeCtrl1, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    Panel5->SetSizer(BoxSizer5);
    BoxSizer5->Fit(Panel5);
    BoxSizer5->SetSizeHints(Panel5);
    Panel6 = new wxPanel(Notebook2, ID_PANEL6, wxDefaultPosition, wxDefaultSize, wxTAB_TRAVERSAL, _T("ID_PANEL6"));
    BoxSizer6 = new wxBoxSizer(wxHORIZONTAL);
    TreeCtrl2 = new wxTreeCtrl(Panel6, ID_TREECTRL2, wxPoint(8,8), wxSize(208,496), wxTR_DEFAULT_STYLE, wxDefaultValidator, _T("ID_TREECTRL2"));
    BoxSizer6->Add(TreeCtrl2, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    Panel6->SetSizer(BoxSizer6);
    BoxSizer6->Fit(Panel6);
    BoxSizer6->SetSizeHints(Panel6);
    Panel7 = new wxPanel(Notebook2, ID_PANEL7, wxDefaultPosition, wxDefaultSize, wxTAB_TRAVERSAL, _T("ID_PANEL7"));
    BoxSizer7 = new wxBoxSizer(wxHORIZONTAL);
    TreeCtrl3 = new wxTreeCtrl(Panel7, ID_TREECTRL3, wxPoint(8,8), wxSize(208,496), wxTR_DEFAULT_STYLE, wxDefaultValidator, _T("ID_TREECTRL3"));
    BoxSizer7->Add(TreeCtrl3, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    Panel7->SetSizer(BoxSizer7);
    BoxSizer7->Fit(Panel7);
    BoxSizer7->SetSizeHints(Panel7);
    Panel8 = new wxPanel(Notebook2, ID_PANEL8, wxDefaultPosition, wxDefaultSize, wxTAB_TRAVERSAL, _T("ID_PANEL8"));
    BoxSizer8 = new wxBoxSizer(wxHORIZONTAL);
    TreeCtrl6 = new wxTreeCtrl(Panel8, ID_TREECTRL4, wxPoint(8,8), wxSize(208,496), wxTR_DEFAULT_STYLE, wxDefaultValidator, _T("ID_TREECTRL4"));
    BoxSizer8->Add(TreeCtrl6, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    Panel8->SetSizer(BoxSizer8);
    BoxSizer8->Fit(Panel8);
    BoxSizer8->SetSizeHints(Panel8);
    Notebook2->AddPage(Panel5, _("2ch"), false);
    Notebook2->AddPage(Panel6, _("まちBBS"), false);
    Notebook2->AddPage(Panel7, _("外部板"), false);
    Notebook2->AddPage(Panel8, _("ユーザー定義"), false);
    BoxSizer2->Add(Notebook2, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    Panel2->SetSizer(BoxSizer2);
    BoxSizer2->Fit(Panel2);
    BoxSizer2->SetSizeHints(Panel2);
    Panel3 = new wxPanel(Notebook1, ID_PANEL3, wxDefaultPosition, wxDefaultSize, wxTAB_TRAVERSAL, _T("ID_PANEL3"));
    BoxSizer3 = new wxBoxSizer(wxHORIZONTAL);
    TreeCtrl5 = new wxTreeCtrl(Panel3, ID_TREECTRL5, wxPoint(8,8), wxSize(232,536), wxTR_DEFAULT_STYLE, wxDefaultValidator, _T("ID_TREECTRL5"));
    BoxSizer3->Add(TreeCtrl5, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    Panel3->SetSizer(BoxSizer3);
    BoxSizer3->Fit(Panel3);
    BoxSizer3->SetSizeHints(Panel3);
    Panel4 = new wxPanel(Notebook1, ID_PANEL4, wxDefaultPosition, wxDefaultSize, wxTAB_TRAVERSAL, _T("ID_PANEL4"));
    BoxSizer4 = new wxBoxSizer(wxHORIZONTAL);
    TreeCtrl6 = new wxTreeCtrl(Panel4, ID_TREECTRL6, wxPoint(8,8), wxSize(232,536), wxTR_DEFAULT_STYLE, wxDefaultValidator, _T("ID_TREECTRL6"));
    BoxSizer4->Add(TreeCtrl6, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    Panel4->SetSizer(BoxSizer4);
    BoxSizer4->Fit(Panel4);
    BoxSizer4->SetSizeHints(Panel4);
    Notebook1->AddPage(Panel2, _("チャンネル一覧"), false);
    Notebook1->AddPage(Panel3, _("お気に入り"), false);
    Notebook1->AddPage(Panel4, _("履歴"), false);
    Notebook3 = new wxNotebook(SplitterWindow1, ID_NOTEBOOK3, wxPoint(272,48), wxSize(616,576), 0, _T("ID_NOTEBOOK3"));
    BoxSizer9 = new wxBoxSizer(wxHORIZONTAL);
    Panel9 = new wxPanel(Notebook3, ID_PANEL9, wxDefaultPosition, wxDefaultSize, wxTAB_TRAVERSAL, _T("ID_PANEL9"));
    wxListCtrl *lstCtrl = new wxListCtrl(Panel9, wxNewId(), wxDefaultPosition, wxDefaultSize, wxLC_REPORT);
    BoxSizer9->Add(lstCtrl, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    Panel9->SetSizer(BoxSizer9);
    BoxSizer9->Fit(Panel9);
    BoxSizer9->SetSizeHints(Panel9);
    Notebook3->AddPage(Panel9, _("なんにもないよ"), false);
    SplitterWindow1->SplitVertically(Notebook1, Notebook3, -20);
    BoxSizer1->Add(SplitterWindow1, 2, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0);
    Panel1->SetSizer(BoxSizer1);
    BoxSizer1->SetSizeHints(Panel1);
    MenuBar1 = new wxMenuBar();
    Menu1 = new wxMenu();
    MenuItem3 = new wxMenuItem(Menu1, ID_Main_Menu_File_OpenTV, _("スレッドウィンドウを表示..."), wxEmptyString, wxITEM_NORMAL);
    Menu1->Append(MenuItem3);
    Menu1->AppendSeparator();
    MenuItem4 = new wxMenuItem(Menu1, ID_Main_Menu_File_Import, _("データのインポート"), wxEmptyString, wxITEM_NORMAL);
    Menu1->Append(MenuItem4);
    MenuItem4->Enable(false);
    MenuItem5 = new wxMenuItem(Menu1, ID_Main_Menu_File_Export, _("データのエクスポート"), wxEmptyString, wxITEM_NORMAL);
    Menu1->Append(MenuItem5);
    MenuItem5->Enable(false);
    Menu1->AppendSeparator();
    MenuItem1 = new wxMenuItem(Menu1, ID_Main_Menu_File_Quit, _("終了\tAlt-F4"), _("Quit the application"), wxITEM_NORMAL);
    Menu1->Append(MenuItem1);
    MenuBar1->Append(Menu1, _("ファイル(&F)"));
    Menu4 = new wxMenu();
    MenuItem8 = new wxMenuItem(Menu4, ID_Main_Menu_Board_Renewal, _("板一覧を取得＆更新"), wxEmptyString, wxITEM_NORMAL);
    Menu4->Append(MenuItem8);
    MenuItem10 = new wxMenuItem(Menu4, ID_Main_Menu_Search_Board, _("板検索..."), wxEmptyString, wxITEM_NORMAL);
    Menu4->Append(MenuItem10);
    MenuBar1->Append(Menu4, _("板(&B)"));
    Menu5 = new wxMenu();
    MenuItem7 = new wxMenuItem(Menu5, ID_Main_Menu_ThreadList_Renewal, _("スレッド一覧を更新する"), wxEmptyString, wxITEM_NORMAL);
    Menu5->Append(MenuItem7);
    MenuItem11 = new wxMenuItem(Menu5, ID_Main_Menu_Search_Thread, _("スレッド検索..."), wxEmptyString, wxITEM_NORMAL);
    Menu5->Append(MenuItem11);
    MenuBar1->Append(Menu5, _("スレッド一覧(&T)"));
    Menu6 = new wxMenu();
    MenuItem12 = new wxMenuItem(Menu6, ID_Main_Menu_Search_Board, _("板検索..."), wxEmptyString, wxITEM_NORMAL);
    Menu6->Append(MenuItem12);
    MenuItem13 = new wxMenuItem(Menu6, ID_Main_Menu_Search_Thread, _("スレッド検索..."), wxEmptyString, wxITEM_NORMAL);
    Menu6->Append(MenuItem13);
    MenuItem14 = new wxMenuItem(Menu6, ID_Main_Menu_Search_Option, _("検索オプション"), wxEmptyString, wxITEM_NORMAL);
    wxMenu *dummy;
    MenuItem15 = new wxMenuItem(dummy
                                /*どのみちsubmenuとして登録されるのでNULLでよいのだが、
                                NULLのままだとwxWidgetsが警告を出すのでダミーとして
                                この値を入れている。*/,
                                ID_Main_Menu_Search_Option_Enable_Regex, _("正規表現検索を有効に"), wxEmptyString, wxITEM_CHECK);
    SearchOptionMenu = new wxMenu;
    SearchOptionMenu->Append(MenuItem15);
    MenuItem14->SetSubMenu(SearchOptionMenu);
    Menu6->Append(MenuItem14);
    MenuBar1->Append(Menu6, _("検索(&R)"));
    Menu3 = new wxMenu();
    MenuItem6 = new wxMenuItem(Menu3, ID_Main_Menu_Setting_Set, _("設定を行う..."), wxEmptyString, wxITEM_NORMAL);
    Menu3->Append(MenuItem6);
    MenuBar1->Append(Menu3, _("設定(&S)"));
    Menu2 = new wxMenu();
    MenuItem9 = new wxMenuItem(Menu2, ID_Main_Menu_Help_ShowReleaseNote, _("リリースノートを見る..."), wxEmptyString, wxITEM_NORMAL);
    Menu2->Append(MenuItem9);
    MenuItem2 = new wxMenuItem(Menu2, ID_Main_Menu_Help_About, _("About...\tF1"), _("Show info about this application"), wxITEM_NORMAL);
    Menu2->Append(MenuItem2);
    MenuBar1->Append(Menu2, _("ヘルプ(&F)"));
    SetMenuBar(MenuBar1);
    StatusBar1 = new wxStatusBar(this, ID_STATUSBAR1, wxST_SIZEGRIP, _T("ID_STATUSBAR1"));
    int __wxStatusBarWidths_1[1] = { -1 };
    int __wxStatusBarStyles_1[1] = { wxSB_NORMAL };
    StatusBar1->SetFieldsCount(1,__wxStatusBarWidths_1);
    StatusBar1->SetStatusStyles(1,__wxStatusBarStyles_1);
    SetStatusBar(StatusBar1);

    Connect(ID_Main_Menu_File_Quit,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&GikoMonaFrame::OnQuit);
    Connect(ID_Main_Menu_Help_About,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&GikoMonaFrame::OnAbout);
//*)
    vListCtrl.push_back(lstCtrl);
    Connect(ID_TREECTRL1,wxEVT_COMMAND_TREE_SEL_CHANGED,(wxObjectEventFunction)&GikoMonaFrame::OnTreeCtrl1SelectionChanged);
    TVWnd = NULL;
}

GikoMonaFrame::~GikoMonaFrame() {
    //(*Destroy(GikoMonaFrame)
    //*)
}

void GikoMonaFrame::OnQuit(wxCommandEvent& WXUNUSED(event)) {
    Close();
}

bool GikoMonaFrame::Destroy() {
    /*for(size_t pageCount = 0;
            pageCount =< Notebook3->GetPageCount();
            ++pageCount) {

    }*/
    return wxFrame::Destroy();
}

void GikoMonaFrame::OnCloseWindow(wxCloseEvent& event) {
    guiMgr->closeMainWindow();
}

void GikoMonaFrame::OnAbout(wxCommandEvent& WXUNUSED(event)) {
    wxAboutDialogInfo info;
    info.SetName(_T("GikoMona"));
    info.SetVersion(_T(gm_VER));
    info.SetCopyright(_T("2009-2010 caprice <gikomona.2chbrowser@gmail.com>"));
    info.SetDescription(_T("GikoMonaをダウソしてくれてありがとうです。。。\n"));
    wxAboutBox(info);
}

void GikoMonaFrame::OnMenuSettingClick(wxCommandEvent& event) {
    SettingWnd = new Setting(NULL, -1, wxPoint(-1, -1), wxSize(-1, -1));
    SettingWnd->Show();
}

void GikoMonaFrame::OnMenuOpenTVClick(wxCommandEvent& event){
    guiMgr->createTVWindow(this, wxNewId());
    guiMgr->showTVWindow();
}

void GikoMonaFrame::OnMenuShowReleaseNoteClick(wxCommandEvent&event){
    guiMgr->createTVWindow(this, wxNewId());
    guiMgr->showTVWindow();
}

void GikoMonaFrame::OnMenuBoardListRenewalClick(wxCommandEvent& event) {
    getBoardList(false);
}

void GikoMonaFrame::getBoardList(bool isLocal) {
    vector< vector<BoardInfo> > vList = guiMgr->getBoardList(isLocal);
    if(!TreeCtrl1->IsEmpty()) { TreeCtrl1->DeleteAllItems(); }
    wxTreeItemId rootID = TreeCtrl1->AddRoot(wxT("2ch.net"), -1, -1, new gmTreeItemData(0));
    wxTreeItemId catID, brdID;
    for(vector< vector<BoardInfo> >::iterator itr = vList.begin(); itr != vList.end(); itr++){
        bool isFirst = true;
        for(vector<BoardInfo>::iterator baseItr = itr->begin(); baseItr != itr->end(); baseItr++){
            if(isFirst){
                catID = TreeCtrl1->AppendItem(rootID, baseItr->brdInfo.BoardName, -1, -1, new gmTreeItemData(0));
                isFirst = false;
            }else{
                brdID = TreeCtrl1->AppendItem(catID, baseItr->brdInfo.BoardName, -1, -1, new gmTreeItemData(baseItr->brdId));
            }
        }
    }
}

void GikoMonaFrame::OnTreeCtrl1SelectionChanged(wxTreeEvent& event) {
    wxTreeItemId id = TreeCtrl1->GetSelection();
    gmTreeItemData *data = static_cast<gmTreeItemData*>(TreeCtrl1->GetItemData(id));
    if(!data->getData()) {
        return;
    }
    getThreadList(data->getData(), false);
}

void GikoMonaFrame::getThreadList(unsigned long brdId, bool isLocal) {
    vector<ThreadInfo> vTList = guiMgr->getTList(brdId, false);
    wxString brdName = TreeCtrl1->GetItemText(TreeCtrl1->GetSelection()); // TreeCtrl1->GetSelection()でなく引数で渡したほうがいいような気がする。
    wxPanel *listBase;
    wxListCtrl *listctrl;
    if(Notebook3->GetPageText(0) != _T("なんにもないよ")) {
        listBase = new wxPanel(Notebook3, wxNewId(), wxDefaultPosition, wxDefaultSize, wxTAB_TRAVERSAL);
        listctrl = new wxListCtrl(listBase, wxNewId(), wxDefaultPosition, wxDefaultSize, wxLC_REPORT);
        wxBoxSizer *sizer = new wxBoxSizer(wxHORIZONTAL);
        sizer->Add(listctrl, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
        listBase->SetSizer(sizer);
        sizer->Fit(listBase);
        sizer->SetSizeHints(listBase);
        Notebook3->AddPage(listBase, brdName, true);
        vListCtrl.push_back(listctrl);
    } else {
        listBase = Panel9;
        Notebook3->SetPageText(0, brdName);
        ListCtrlList::iterator itr = vListCtrl.begin();
        listctrl = *itr;
    }

    wxListItem ItemCol0, ItemCol1, ItemCol2, ItemCol3, ItemCol4, ItemCol5, ItemCol6;
    ItemCol0.SetText(_T("タイトル"));
    ItemCol1.SetText(_T("取得件数"));
    ItemCol2.SetText(_T("最新取得日時"));
    ItemCol3.SetText(_T("最終書き込み"));
    ItemCol4.SetText(_T("新着件数"));
    ItemCol5.SetText(_T("新着日時"));
    ItemCol6.SetText(_T("勢い"));

    listctrl->InsertColumn(0, ItemCol0);
    listctrl->InsertColumn(1, ItemCol1);
    listctrl->InsertColumn(2, ItemCol2);
    listctrl->InsertColumn(3, ItemCol3);
    listctrl->InsertColumn(4, ItemCol4);
    listctrl->InsertColumn(5, ItemCol5);
    listctrl->InsertColumn(6, ItemCol6);

    size_t i = 0;
    for(vector<ThreadInfo>::iterator itr = vTList.begin(); itr != vTList.end(); itr++){
        listctrl->InsertItem(i, itr->thrdInfo.Title, 0);
        listctrl->SetItemData(i, (long)itr->thrdId);
        listctrl->SetItem(i, 1, itr->thrdInfo.ResCount);
        i++;
    }
    Connect(listctrl->GetId(), wxEVT_COMMAND_LIST_ITEM_SELECTED, (wxObjectEventFunction)&GikoMonaFrame::OnListCtrlItemClicked);
}

void GikoMonaFrame::OnListCtrlItemClicked(wxListEvent& event){
    int page = Notebook3->GetSelection();
    getThread(Notebook3->GetPageText((size_t)page), event.GetData(), event.GetText(), false);
}

void GikoMonaFrame::getThread(const wxString& boardName, unsigned long thrdId, const wxString& threadTitle, bool isLocal) {
    ResData res = guiMgr->getThread(thrdId, threadTitle, isLocal);
    guiMgr->createTVWindow(this, wxNewId());
    guiMgr->showTVWindow();
    guiMgr->getTVWindow()->addThread(boardName, res.Text, res.Title);
}

