#include "gmDefs.h"
#include <fstream>

#include <wx/object.h>
#include "LogMgr.h"

bool LogMgr::init() {
    wxString filename =
                    #ifdef __WXDEBUG__
                        _T("debug.log")
                    #else
                        _T("gikomona.log")
                    #endif
                      ;
    file = new wxTextFile(filename);
    if(wxFileExists(filename)) {
        if(!file->Open()) {
            isOpened = false;
        }else{
            isOpened = true;
            writeInfo();
        }
    }else{
        if(!file->Create()) {
            isOpened = false;
        }else{
            isOpened = true;
            writeInfo();
        }
    }
    return isOpened;
}

bool LogMgr::done() {
    file->Write();
    file->Close();
    delete file;
}

bool LogMgr::writeInfo() {
    file->AddLine(
    #ifdef __WXDEBUG__
        _T("--- it is debug build log... ---\n")
    #else
        _T("--- it is debug log... ---\n")
        _T("--- meta info ---\n")
        _T("version    : ") _T(gm_VER) _T("\n")
        _T("build date : ") _T(__DATE__) _T("\n")
        _T("--- end of meta info ---\n")
    #endif
    );
    file->Write();
}

bool LogMgr::write(const wxString& msg) {
    if(isOpened) {
        file->AddLine(msg);
        file->Write();
    }
}

bool LogMgr::dbgWrite(const wxString& msg) {
    #ifdef __WXDEBUG__
        write(msg);
    #endif
}

bool writeToFile(const wxString& msg) {

}

