#include <map>
#include <algorithm>

#include "TVWindow.h"
#include "GikoMonaMain.h"

#include <wx/textfile.h>
#include <wx/utils.h>
#include <wx/aui/aui.h>
#include <wx/aui/auibook.h>

//(*InternalHeaders(TVWindow)
#include <wx/artprov.h>
#include <wx/bitmap.h>
#include <wx/intl.h>
#include <wx/image.h>
#include <wx/string.h>
//*)

using namespace std;

//(*IdInit(TVWindow)
const long TVWindow::ID_HTMLWINDOW1 = wxNewId();
const long TVWindow::ID_PANEL3 = wxNewId();
const long TVWindow::ID_NOTEBOOK2 = wxNewId();
const long TVWindow::ID_PANEL2 = wxNewId();
const long TVWindow::ID_NOTEBOOK1 = wxNewId();
const long TVWindow::ID_PANEL1 = wxNewId();
const long TVWindow::ID_TV_Menu_Copy = wxNewId();
const long TVWindow::ID_TV_Menu_URLCopy = wxNewId();
const long TVWindow::ID_TV_Menu_OpenURLByNoDefaultBrowser = wxNewId();
const long TVWindow::ID_STATUSBAR1 = wxNewId();
const long TVWindow::ID_TOOLBARITEM1 = wxNewId();
const long TVWindow::ID_TOOLBARITEM2 = wxNewId();
const long TVWindow::ID_TOOLBAR1 = wxNewId();
//*)
BEGIN_EVENT_TABLE(TVWindow,wxFrame)
	//(*EventTable(TVWindow)
	EVT_TOOL(ID_TOOLBARITEM1, TVWindow::OnToolbarCloseClicked)
	EVT_CLOSE(TVWindow::OnCloseWindow)
	//*)
    EVT_TOOL(ID_TOOLBARITEM2, TVWindow::OnToolbarChangeTabStyleClicked)
END_EVENT_TABLE()

TVWindow::TVWindow(gmGuiMgr *gui, wxWindow* parent,wxWindowID id,const wxPoint& pos,const wxSize& size)
{
    guiMgr = gui;
	wxMenuItem* MenuItem2;
	wxMenuItem* MenuItem1;
	wxMenuItem* MenuItem3;
    //const wxBitmap iconTab(*(wxGetApp().icons.iconArray[ICON_TAB]));
	//(*Initialize(TVWindow)
	wxBoxSizer* BoxSizer4;
	wxBoxSizer* BoxSizer2;
	wxBoxSizer* BoxSizer1;
	wxBoxSizer* BoxSizer3;

	Create(parent, wxID_ANY, _("スレッド - GikoMona"), wxDefaultPosition, wxDefaultSize, wxDEFAULT_FRAME_STYLE, _T("wxID_ANY"));
	SetClientSize(wxSize(787,577));
	Panel1 = new wxPanel(this, ID_PANEL1, wxPoint(288,424), wxDefaultSize, wxTAB_TRAVERSAL, _T("ID_PANEL1"));
	BoxSizer1 = new wxBoxSizer(wxHORIZONTAL);
	Notebook1 = new wxNotebook(Panel1, ID_NOTEBOOK1, wxDefaultPosition, wxDefaultSize, wxNB_FIXEDWIDTH, _T("ID_NOTEBOOK1"));
	Panel2 = new wxPanel(Notebook1, ID_PANEL2, wxDefaultPosition, wxDefaultSize, wxTAB_TRAVERSAL, _T("ID_PANEL2"));
	BoxSizer2 = new wxBoxSizer(wxHORIZONTAL);
	Notebook2 = new wxNotebook(Panel2, ID_NOTEBOOK2, wxDefaultPosition, wxDefaultSize, wxNB_FIXEDWIDTH, _T("ID_NOTEBOOK2"));
	Panel3 = new wxPanel(Notebook2, ID_PANEL3, wxDefaultPosition, wxDefaultSize, wxTAB_TRAVERSAL, _T("ID_PANEL3"));
	BoxSizer3 = new wxBoxSizer(wxHORIZONTAL);
	HtmlWindow1 = new wxHtmlWindow(Panel3, ID_HTMLWINDOW1, wxDefaultPosition, wxDefaultSize, wxHW_SCROLLBAR_AUTO, _T("ID_HTMLWINDOW1"));
	BoxSizer3->Add(HtmlWindow1, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	Panel3->SetSizer(BoxSizer3);
	BoxSizer3->Fit(Panel3);
	BoxSizer3->SetSizeHints(Panel3);
	Notebook2->AddPage(Panel3, _("なんにもないよ"), false);
	BoxSizer2->Add(Notebook2, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	Panel2->SetSizer(BoxSizer2);
	BoxSizer2->Fit(Panel2);
	BoxSizer2->SetSizeHints(Panel2);
	Notebook1->AddPage(Panel2, _("なんにもないよ"), false);
	BoxSizer1->Add(Notebook1, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	Panel1->SetSizer(BoxSizer1);
    BoxSizer1->Fit(Panel1);
	BoxSizer1->SetSizeHints(Panel1);
	MenuItem1 = new wxMenuItem((&Menu1), ID_TV_Menu_Copy, _("選択されたテキストをコピー"), wxEmptyString, wxITEM_NORMAL);
	Menu1.Append(MenuItem1);
	MenuItem1->Enable(false);
	MenuItem2 = new wxMenuItem((&Menu1), ID_TV_Menu_URLCopy, _("このURLをコピー"), wxEmptyString, wxITEM_NORMAL);
	Menu1.Append(MenuItem2);
	MenuItem2->Enable(false);
	Menu1.AppendSeparator();
	MenuItem3 = new wxMenuItem((&Menu1), ID_TV_Menu_OpenURLByNoDefaultBrowser, _("指定したブラウザで開く..."), wxEmptyString, wxITEM_NORMAL);
	Menu1.Append(MenuItem3);
	MenuItem3->Enable(false);
	StatusBar1 = new wxStatusBar(this, ID_STATUSBAR1, wxST_SIZEGRIP, _T("ID_STATUSBAR1"));
	int __wxStatusBarWidths_1[1] = { -10 };
	int __wxStatusBarStyles_1[1] = { wxSB_NORMAL };
	StatusBar1->SetFieldsCount(1,__wxStatusBarWidths_1);
	StatusBar1->SetStatusStyles(1,__wxStatusBarStyles_1);
	SetStatusBar(StatusBar1);
	ToolBar1 = new wxToolBar(this, ID_TOOLBAR1, wxDefaultPosition, wxDefaultSize, wxTB_HORIZONTAL, _T("ID_TOOLBAR1"));
	ToolBarItem1 = ToolBar1->AddTool(ID_TOOLBARITEM1, _("閉じる"), wxArtProvider::GetBitmap(wxART_MAKE_ART_ID_FROM_STR(_T("wxART_CROSS_MARK")),wxART_TOOLBAR), wxNullBitmap, wxITEM_NORMAL, _("板を閉じる"), wxEmptyString);
	//ToolBarItem2 = ToolBar1->AddTool(ID_TOOLBARITEM2, _("タブスタイル"), wxBitmap(wxBITMAP(gm_App_Tab_BITMAP)), wxNullBitmap, wxITEM_NORMAL, _("タブのスタイルを変更します..."), wxEmptyString);
	ToolBarItem2 = ToolBar1->AddTool(ID_TOOLBARITEM2, _("タブスタイル"), wxGetApp().icons.tab, wxNullBitmap, wxITEM_NORMAL, _("タブのスタイルを変更します..."), wxEmptyString);
	ToolBar1->Realize();
	SetToolBar(ToolBar1);
	//*)

    wxSize client_size = GetClientSize();
    /*auiMgr = new wxAuiManager(this);
    auiNotebook1 = new wxAuiNotebook(this, wxNewId(),
                                     wxPoint(client_size.x, client_size.y), wxSize(430,200),
                                     wxAUI_NB_DEFAULT_STYLE | wxAUI_NB_WINDOWLIST_BUTTON);*/
    Connect(ID_HTMLWINDOW1, wxEVT_COMMAND_HTML_LINK_CLICKED, (wxObjectEventFunction)&TVWindow::OnHtmlLinkClicked);
    threadNoteList.push_back(Notebook2);
	htmlWndList.push_back(HtmlWindow1);
}

TVWindow::~TVWindow(){
	//(*Destroy(TVWindow)
	//*)
	//auiMgr->UnInit();
}

void TVWindow::OnToolbarCloseClicked(wxCommandEvent& event){
    if(Notebook1->GetPageCount() != 1) {
        // アイテムはみんなサイザーの下に入っているのでこっちで面倒見なくてもOK
        size_t slct = static_cast<size_t>(Notebook1->GetSelection());
        Notebook1->DeletePage(slct);
        list<wxNotebook*>::iterator itrNote = rotateItr<wxNotebook*>(itrNote, threadNoteList, slct);
        // GetFirst()で必ずwxPanel/wxHtmlWindowが取得できるとは保障されてないから、
        // いかにもバグを誘発しそう。
        wxHtmlWindow *begin = static_cast<wxHtmlWindow*> (
                            &(*((
                                static_cast<wxPanel*> ((
                                    *(
                                        (*itrNote)->GetChildren().GetFirst()
                                    )).GetData()
                                ))->GetChildren().GetFirst())->GetData())
                            ),
                     *end = static_cast<wxHtmlWindow*> (
                            &(*((
                                static_cast<wxPanel*> ((
                                    *(
                                        (*itrNote)->GetChildren().GetLast()
                                    )).GetData()
                                ))->GetChildren().GetFirst())->GetData())
                            );
        htmlWndList.erase(find(htmlWndList.begin(), htmlWndList.end(), begin),
                          find(htmlWndList.begin(), htmlWndList.end(), end));
        threadNoteList.erase(itrNote);
    }
}

void TVWindow::OnToolbarChangeTabStyleClicked(wxCommandEvent& event) {
    tabMgr = new TabMgr(Panel1, htmlWndList, threadNoteList, auiNoteList);
    wxMenu tabStyleMenu;
    int basicTabId = wxNewId(),
        auiTabId = wxNewId()/*,
        treeTabId = wxNewId(),
        threadTreeTabId = wxNewId()*/
        ;
    tabStyleMenu.Append(basicTabId, _T("標準のタブにする..."));
    tabStyleMenu.Append(auiTabId, _T("ドラッグ可能なタブにする..."));
    //tabStyleMenu.Append(treeTabId, _T("ツリー型タブにする..."));
    //tabStyleMenu.Append(threadTreeTabId, _T("閲覧中のスレッドタブをツリー化..."));
    Connect(basicTabId, wxEVT_COMMAND_MENU_SELECTED, (wxObjectEventFunction)&TVWindow::OnChangeStyle2BasicTab);
    Connect(auiTabId, wxEVT_COMMAND_MENU_SELECTED, (wxObjectEventFunction)&TVWindow::OnChangeStyle2AuiTab);
    //Connect(treeTabId, wxEVT_COMMAND_MENU_SELECTED, (wxObjectEventFunction)&TVWindow::OnChangeStyle2TreeTab);
    //Connect(threadTreeTabId, wxEVT_COMMAND_MENU_SELECTED, (wxObjectEventFunction)&TVWindow::OnChangeStyle2ThreadTreeTab);
    PopupMenu(&tabStyleMenu);
}

void TVWindow::OnChangeStyle2BasicTab(wxMenuEvent& event) {
    if(Notebook1->IsShown()) { return; }
    tabMgr->copyAllControlsFromAuiTab(auiMgr, auiNotebook1);
}

void TVWindow::OnChangeStyle2AuiTab(wxMenuEvent& event) {
    if(auiNotebook1->IsShown()) { return; }
    tabMgr->copyAllControlsFromBasicTab(Notebook1);
}
/*
void TVWindow::OnChangeStyle2TreeTab(wxMenuEvent& event) {
    if(treeCtrl1->IsShown()) { return; }
}

void TVWindow::OnChangeStyle2ThreadTreeTab(wxMenuEvent& event) {
    ;
}
*/
void TVWindow::OnCloseWindow(wxCloseEvent& event) {
    guiMgr->closeTVWindow();
}

void TVWindow::OnHtmlLinkClicked(wxHtmlLinkEvent& event) {
    wxLaunchDefaultBrowser(event.GetLinkInfo().GetHref());
}

pair<bool, size_t>& TVWindow::isAlreadyOpened(const wxString& bookName, wxNotebook *book){
    for(size_t i = 0; i < book->GetPageCount(); i++){
        if(bookName == book->GetPageText(i)){
            bookPair.first = true;
            bookPair.second = i;
            return bookPair;
        }
    }
    bookPair.first = false;
    bookPair.second = 0;
    return bookPair;
}

void TVWindow::addThreadNote(wxNotebook *threadNotebook, wxPanel *threadNotePanel, wxHtmlWindow *htmlWnd){
    wxBoxSizer *threadNoteSizer = new wxBoxSizer(wxHORIZONTAL);
    threadNoteSizer->Add(htmlWnd, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    threadNotePanel->SetSizer(threadNoteSizer);
    threadNoteSizer->Fit(threadNotePanel);
    threadNoteSizer->SetSizeHints(threadNotePanel);
    htmlWndList.push_back(htmlWnd);
}

void TVWindow::addThread(const wxString& board, const wxString& text, const wxString& title){
    if(Notebook1->GetPageText(0) == _T("なんにもないよ")){
        Notebook1->SetPageText(0, board);
        Notebook2->SetPageText(0, title);
        HtmlWindow1->SetPage(text);
        return;
    }
    wxPanel *boardNotePanel, *threadNotePanel;
    wxBoxSizer *boardNoteSizer = new wxBoxSizer(wxHORIZONTAL);
    wxNotebook *threadNotebook;
    wxHtmlWindow *htmlWnd;
    bool isOpenedBoardNote = false, isOpenedThreadNote = false;
    size_t boardNoteNum, threadNoteNum;
    list<wxNotebook*>::iterator threadNote_itr;
    list<wxHtmlWindow*>::iterator html_itr;
    pair<bool, size_t> boardNoteInfo = isAlreadyOpened(board, Notebook1), threadNoteInfo;
    if(boardNoteInfo.first){
        threadNote_itr = rotateItr<wxNotebook*>(threadNote_itr, threadNoteList, boardNoteInfo.second);
        threadNoteInfo = isAlreadyOpened(title, *threadNote_itr);
        if(!threadNoteInfo.first){
            threadNotePanel = new wxPanel(*threadNote_itr, wxNewId(), wxDefaultPosition, wxDefaultSize, wxTAB_TRAVERSAL);
            long htmlWinId = wxNewId();
            Connect(htmlWinId, wxEVT_COMMAND_HTML_LINK_CLICKED, (wxObjectEventFunction)&TVWindow::OnHtmlLinkClicked);
            htmlWnd = new wxHtmlWindow(threadNotePanel, htmlWinId, wxDefaultPosition, wxSize(864,568), wxHW_SCROLLBAR_AUTO);
            addThreadNote(*threadNote_itr, threadNotePanel, htmlWnd);
            (*threadNote_itr)->AddPage(threadNotePanel, title, true);
        }else{
            (*threadNote_itr)->SetSelection(threadNoteInfo.second);
            html_itr = rotateItr<wxHtmlWindow*>(html_itr, htmlWndList, threadNoteInfo.second);
            htmlWnd = *html_itr;
        }
    }else{
        boardNotePanel = new wxPanel(Notebook1, wxNewId(), wxDefaultPosition, wxDefaultSize, wxTAB_TRAVERSAL);
        threadNotebook = new wxNotebook(boardNotePanel, wxNewId(), wxDefaultPosition, wxSize(882,611), wxNB_FIXEDWIDTH);
        threadNotePanel = new wxPanel(threadNotebook, wxNewId(), wxDefaultPosition, wxDefaultSize, wxTAB_TRAVERSAL);
        long htmlWinId = wxNewId();
        Connect(htmlWinId, wxEVT_COMMAND_HTML_LINK_CLICKED, (wxObjectEventFunction)&TVWindow::OnHtmlLinkClicked);
        htmlWnd = new wxHtmlWindow(threadNotePanel, htmlWinId, wxDefaultPosition, wxSize(864,568), wxHW_SCROLLBAR_AUTO);
        threadNoteList.push_back(threadNotebook);
        addThreadNote(threadNotebook, threadNotePanel, htmlWnd);
        threadNotebook->AddPage(threadNotePanel, title, true);
        boardNoteSizer->Add(threadNotebook, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
        boardNotePanel->SetSizer(boardNoteSizer);
        boardNoteSizer->Fit(boardNotePanel);
        boardNoteSizer->SetSizeHints(boardNotePanel);
        Notebook1->AddPage(boardNotePanel, board, true);
    }
    htmlWnd->SetPage(text);
}
