#include "gmErrorDialog.h"

#include <wx/clipbrd.h>
#include <wx/app.h>

//(*InternalHeaders(gmErrorDialog)

#include <wx/intl.h>

#include <wx/string.h>

//*)

//(*IdInit(gmErrorDialog)
const long gmErrorDialog::ID_HTMLWINDOW1 = wxNewId();
const long gmErrorDialog::ID_STATICLINE1 = wxNewId();
const long gmErrorDialog::ID_BUTTON1 = wxNewId();
const long gmErrorDialog::ID_BUTTON2 = wxNewId();
//*)

BEGIN_EVENT_TABLE(gmErrorDialog,wxDialog)
	//(*EventTable(gmErrorDialog)
	//*)
END_EVENT_TABLE()

gmErrorDialog::gmErrorDialog(wxWindow* parent,wxWindowID id,const wxPoint& pos,const wxSize& size)
{
	//(*Initialize(gmErrorDialog)
	Create(parent, id, wxEmptyString, wxDefaultPosition, wxDefaultSize, 0, _T("id"));
	SetClientSize(wxSize(384,229));
	Move(wxDefaultPosition);
	HtmlWindow1 = new wxHtmlWindow(this, ID_HTMLWINDOW1, wxPoint(8,8), wxSize(368,176), wxHW_SCROLLBAR_AUTO, _T("ID_HTMLWINDOW1"));
	StaticLine1 = new wxStaticLine(this, ID_STATICLINE1, wxPoint(8,192), wxSize(368,2), wxLI_HORIZONTAL, _T("ID_STATICLINE1"));
	Button1 = new wxButton(this, ID_BUTTON1, _("OK(&O)"), wxPoint(304,200), wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON1"));
	Button2 = new wxButton(this, ID_BUTTON2, _("クリップボードにコピー(&C)"), wxPoint(168,200), wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON2"));
	//*)
}

gmErrorDialog::~gmErrorDialog()
{
	//(*Destroy(gmErrorDialog)
	//*)
}

void gmErrorDialog::showError(const wxString& cause, const wxString& msg, const wxString& classname, const wxString& funcname, const wxString& linenum) {
    wxString html;
    html =  _T("<font color=\"red\"><b>えらー！</b></font><br>\n");
    html += _T("   原因    : ") + cause + _T("<br>\n");
    html += _T("           @ ") + classname + _T("::") + funcname + _T(" (") + linenum + _T(")<br>\n");
    html += _T("メッセージ : ") + msg + _T("<br>\n");
    HtmlWindow1->SetPage(html);
}

void gmErrorDialog::OnCopy2ClipBoardButtonClicked(wxCommandEvent& event) {
    if(wxTheClipboard->Open()) {
        wxTheClipboard->SetData( new wxTextDataObject() );
        wxTheClipboard->Close();
    }
}

void gmErrorDialog::OnButtonOKClicked(wxCommandEvent& event) {
    Close();
}

void gmShowErrorDialog(const wxString& cause,        const wxString& msg,
                       const wxString& classname,    const wxString& funcname,
                       const wxString& linenum) {
    gmErrorDialog dlg(NULL);
    dlg.showError(cause, msg, classname, funcname, linenum);
    dlg.Show(true);
}
